/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== about.c: "about" pour FlashTris
   ====

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/


#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <math.h>

#ifndef MSDOS
    #include <vgakeyboard.h>
#endif

#include "ftris.h"
#include "about.h"
#include "key.h"
#include "menu.h"
#include "menu_gfx.h"
#include "video.h"
#include "./module/mod.h"


unsigned char   *texte_about[2] =
                { "                "
                  "FlashTris  " VERSION " released " DATE_EN ", started on " DATE_DEBUT_EN
                  "  by FlashCode (Sebastien HELLEU)    "
                  "% done:  grafx : 90%  -  music : 100%  -  menu : 80%  -  "
                  "game : 40%  -  network : 20%  ---  "
                  "TOTAL : 55 % ......      "
                  "After Demoniac-Tris fury, this is FlashTris !........"
                  "fast and nice 'tris-like !   And don't think \"oh, another "
                  "tris-like, boring...\"  NO ! NO ! NO !  FlashTris has "
                  "new features: incredible menu, new pieces (with editor), "
                  "new options, demoniac musics, bonus levels, network teams, "
                  "cooperative with computers, death match by network, ......   "
                  "                 Special thanks to my brother Rapass for "
                  "his fabulous ideas (especially menu)       "
                  "Hello to CoDeMaNCeR, MouSTiK, my family and Aude M. !             "
                  "Other games by FlashCode: Demoniac-Tris, Nibble, "
                  "Bubble Bobble, Demoniac Fight, HellTris, HellFight, "
                  "Trap, (X)Maxi-MineHunt, HellMaze, ......  "
                  "they're all free, download them now !.....      "
                  "... Thanks to YOU for playing FlashTris !........."
                  "                                ",
                  /* --------------------------------------------------------- */
                  "                "
                  "FlashTris  " VERSION " du " DATE_FR ", demarre le " DATE_DEBUT_FR
                  "  par FlashCode (Sebastien HELLEU)    "
                  "% fait:  graphisme : 90%  -  musique : 100%  -  menu : 80%  -  "
                  "jeu : 40%  -  reseau : 20%  ---  "
                  "TOTAL : 55 % ......      "
                  "Apres la furie de Demoniac-Tris, c'est FlashTris !........"
                  "joli et rapide 'tris-like !   Et ne pensez pas \"oh, un autre "
                  "tris-like, ennuyeux...\"  NON ! NON ! NON !  FlashTris a "
                  "beaucoup de nouveautes: menu incroyable, nouvelles pieces (avec editeur), "
                  "nouvelles options, musiques dementielles, niveaux bonus, equipes en reseau, "
                  "cooperatif avec des ordinateurs, duel mortel par reseau, ......   "
                  "                 Remerciements speciaux a mon frere Rapass pour "
                  "ses idees lumineuses (en particulier le menu)       "
                  "Coucou a CoDeMaNCeR, MouSTiK, ma famille et Aude M. !             "
                  "Autres jeux par FlashCode: Demoniac-Tris, Nibble, "
                  "Bubble Bobble, Demoniac Fight, HellTris, HellFight, "
                  "Trap, (X)Maxi-MineHunt, HellMaze, ......  "
                  "ils sont tous gratuits, telechargez-les maintenant !.....      "
                  "... Merci a vous de jouer a FlashTris !........."
                  "                                " };

#define NB_POINTS   (92)

int             coul_pixel[8] = { 238, 138, 179, 133, 202, 164, 101, 185 };

int             cptr_affiche_volume;

int             numero_msg_copyright;
int             cptr_msg_copyright;
unsigned char   *msg_copyright[2][NB_MSG_COPYRIGHT] =
                { { "FlashTris " VERSION " - " DATE_EN_LONG,
                    "Web: " SITE_WEB,
                    "E-mail: " EMAIL,
                    "Programming : Sebastien HELLEU",
                    "Graphics : Sebastien HELLEU",
                    "Graphics made with Deluxe Paint II and The Gimp",
                    "Musics : Dr.Awesome, Paradox, and other",
                    "Demoniac Module Player (c) 1998-2000 by FlashCode",
                    "Cross-platform graphics engine (c) 1999-2000 by FlashCode",
                    "Enjoy FlashTris !" },
                  { "FlashTris " VERSION " - " DATE_FR_LONG,
                    "Web: " SITE_WEB,
                    "E-mail: " EMAIL,
                    "Programmation : Sebastien HELLEU",
                    "Graphismes : Sebastien HELLEU",
                    "Graphismes realises avec Deluxe Paint II et The Gimp",
                    "Musiques : Dr.Awesome, Paradox, et d'autres",
                    "Demoniac Module Player (c) 1998-2000 par FlashCode",
                    "Moteur graphique multi-plateformes (c) 1999-2000 par FlashCode",
                    "Vive FlashTris !" } };


/*
 * fade_to_sbpoll: fondu d'une palette vers une autre avec appel de SbPoll
 *                 *********** DOS UNIQUEMENT !!! ************
 */

#ifdef MSDOS
/*void fade_to_sbpoll(unsigned char *from_pal, unsigned char *to_pal,
                    int nb_skip, int delay_pause)
{
    unsigned char   pal_actuelle[768];
    int             i, j;

    memcpy(pal_actuelle, from_pal, 768);
    setpal(pal_actuelle);
    for (j = 0; j < 64; j++)
    {
        for (i = 0; i < 768; i++)
            if (pal_actuelle[i] < to_pal[i])
                pal_actuelle[i]++;
            else
                if (pal_actuelle[i] > to_pal[i])
                    pal_actuelle[i]--;
        if ((j % nb_skip) == 0)
        {
            if (sb16)
                sbpoll();
            waitretrace();
            setpal(pal_actuelle);
            usleep(delay_pause);
        }
    }
    if (sb16)
        sbpoll();
    waitretrace();
    setpal(to_pal);
}*/
#endif

/*
 * about_efface_volume: efface le volume
 */

void about_efface_volume()
{
    copy_v2s_xy(VSCR_AUTRES+5, scr_nbx-31, scr_nby-6, 31, 6);
}

/*
 * about_affiche_volume: affiche le volume en bas a droite
 */

void about_affiche_volume()
{
    about_efface_volume();
    write_xy_s_c_o(ECRAN_REEL, scr_nbx-31, scr_nby-6, 119, 0, 22,
        "Vol:%d%%", (volume*100)/VOLUME_MAX);
    cptr_affiche_volume = 100;
}

void affiche_msg_copyright()
{
    write_xy_s_c_o(ECRAN_REEL,
        (scr_nbx-text_length(msg_copyright[langue][numero_msg_copyright]))/2-14,
        138, 1, 0, 123, msg_copyright[langue][numero_msg_copyright]);
}

void about_texte_defile()
{
    int             i, j, sinus[NB_POINTS], x, y;
    int             ligne, limite;
    unsigned char   *carac;
    double          z;

    z = 0;
    for (i = 0; i < NB_POINTS; i++)
    {
        z += (3*M_PI)/90;
        sinus[NB_POINTS-1-i] = sin(z)*13+(double)(i)*0.2;
    }
    /*for (i = 0; i < 105; i++)
    {
        z += (3*M_PI)/90;
        sinus[i] = (sin(z)*15+(double)(i)*0.7)+10;
    }*/

    carac = fonte[texte_about[langue][0]];
    limite = strlen(texte_about[langue])*8-1;
    ligne = 0;

    key_tab[SCANCODE_ENTER] = 0;
    key_tab[SCANCODE_KEYPADENTER] = 0;
    key_tab[1] = 0;

    #ifdef MSDOS
    if (sb16)
        restaure_int_timer();
    #endif

    while ( (!key_tab[SCANCODE_ENTER])
        && (!key_tab[SCANCODE_KEYPADENTER])
        && (!key_tab[1]) )
    {
        #ifndef MSDOS
        if (!X_Window)
            keyboard_update();
        #endif

        if (sb16)
        {
            /* augmentation volume  '+' */
            if ( (key_tab[78]) && (volume < VOLUME_MAX) )
            {
                if (key_tab[SCANCODE_LEFTCONTROL] || key_tab[SCANCODE_RIGHTCONTROL])
                    volume = (volume > VOLUME_MAX-5)?VOLUME_MAX:volume+5;
                else
                    volume++;
                setvolume(volume);
                about_affiche_volume();
                key_tab[78] = 0;
            }
            /* diminution volume '-' */
            if ( (key_tab[74]) && (volume > 0) )
            {
                if (key_tab[SCANCODE_LEFTCONTROL] || key_tab[SCANCODE_RIGHTCONTROL])
                    volume = (volume < 5)?0:volume-5;
                else
                    volume--;
                setvolume(volume);
                about_affiche_volume();
                key_tab[74] = 0;
            }
        }

        #ifdef MSDOS
        if (sb16)
            sbpoll();
        #endif
        waitretrace();

        /*for (i = 0; i < 8; i++)
            for (j = 0; j < 13*8; j++)
            {
                ofs = 28160+i*scr_nbx*3+j*3;
                putpixel_ofs(ECRAN_REEL, ofs+sinus[j]*scr_nbx,
                    getpixel_ofs(ECRAN_REEL, ofs+sinus[j+1]*scr_nbx+3));
            }
        for (i = 0; i < 8; i++)
            if ( (carac[i] & (1 << (7-(ligne % 8)))) != 0)
                putpixel_ofs(ECRAN_REEL, 28160+13*8*3+i*scr_nbx*3+sinus[13*8]*scr_nbx, 144);
            else
            {
                ofs = 28160+13*8*3+i*scr_nbx*3+sinus[13*8]*scr_nbx;
                putpixel_ofs(ECRAN_REEL, ofs, vscreen[VSCR_AUTRES+5][ofs]);
            }*/

        for (j = 0; j < NB_POINTS; j++)
        {
            carac = fonte[texte_about[langue][((ligne+j)%limite)/8]];
            for (i = 0; i < 8; i++)
            {
                /*ofs = 28160+j*3+i*scr_nbx*3+sinus[j]*scr_nbx;*/
                x = 45+j*3;
                y = 151+i*3+sinus[j];
                if ( (carac[i] & (1 << (7-((ligne+j) % 8)))) != 0)
                {
                    /*putpixel_ofs(ECRAN_REEL, ofs, 238);*/
                    ligne_horiz(ECRAN_REEL, x, x, y, 53/*238*/);
                    ligne_horiz(ECRAN_REEL, x+1, x+1, y, 186/*6*/);
                    ligne_horiz(ECRAN_REEL, x, x, y+1, 1/*37*/);
                }
                else
                    copy_v2s_xy(VSCR_AUTRES+5, x, y, 2, 2);
            }
        }

        if (key_tab[SCANCODE_CURSORBLOCKLEFT])
        {
            for (i = 0; i < (key_tab[SCANCODE_LEFTCONTROL] | key_tab[SCANCODE_RIGHTCONTROL])+2; i++)
                if (ligne > 0)
                    ligne--;
        }
        else
        {
            if (key_tab[SCANCODE_CURSORBLOCKRIGHT])
                ligne += (key_tab[SCANCODE_LEFTCONTROL] | key_tab[SCANCODE_RIGHTCONTROL])+2;
            else
                ligne++;
            if (ligne > limite)
                ligne -= limite+1;
        }
        /*if ( (ligne % 8) == 0)
            carac = fonte[texte_about[ligne/8]];*/

        if (cptr_affiche_volume > 0)
        {
            cptr_affiche_volume--;
            if (cptr_affiche_volume == 0)
                about_efface_volume();
        }

        cptr_msg_copyright = (cptr_msg_copyright+1)%500;
        if (cptr_msg_copyright == 0)
        {
            copy_v2s_xy(VSCR_AUTRES+5, 0, 138, scr_nbx, 6);
            numero_msg_copyright = (numero_msg_copyright+1)%NB_MSG_COPYRIGHT;
            /*if (email)
                write_xy_s_c_o(ECRAN_REEL, x_email, 138, 1, 0, 123, "E-mail: " EMAIL);
            else
                write_xy_s_c_o(ECRAN_REEL, x_site, 138, 1, 0, 123, "Web: " SITE_WEB);*/
            affiche_msg_copyright();
        }
    }

    #ifdef MSDOS
    if (sb16)
        detourne_int_timer();
    #endif

    key_tab[SCANCODE_ENTER] = 0;
    key_tab[SCANCODE_KEYPADENTER] = 0;
    key_tab[1] = 0;
}

void about_flashtris()
{
    int             i, coul_garde;
    unsigned char   pal_cible[768];

    copy_s2v(VSCR_AUTRES+4);
    clear_screen();
    memset(palette, 0, 768);
    setpal(palette);

    if (sb16)
        change_music("stuntman.dat", 0);

    load_dat("aboutseb.dat", VSCR_AUTRES+5);
    memcpy(pal_cible, palette, 768);
    coul_garde = rand()%2*2;
    for (i = 1; i < 768; i += 3)
    {
        palette[i+((coul_garde+1)%3)] = 0;
        palette[i+((coul_garde+2)%3)] = 0;
    }
    setpal(palette);
    write_xy_s_c_o(VSCR_AUTRES+5, 81, 130, 119/*6*/, 0, 22/*185*/, "(C) 1999-2001 BY SEBASTIEN HELLEU");

    cptr_affiche_volume = 0;

    numero_msg_copyright = 0;
    cptr_msg_copyright = 0;

    copy_v2s(VSCR_AUTRES+5);
    affiche_msg_copyright();
    setpal(palette);
    /*  trouver une solution pour le DOS */
    #ifndef MSDOS
    usleep(10000);
    #endif
    #ifdef MSDOS
    fade_to(palette, pal_cible, 1, 10000);
    #else
    fade_to(palette, pal_cible, 1, 10000);
    #endif

    about_texte_defile();

    #ifdef MSDOS
    fade_to(pal_cible, palette, 1, 10000);
    #else
    fade_to(pal_cible, palette, 1, 10000);
    #endif
    /*  trouver une solution pour le DOS */
    #ifndef MSDOS
    usleep(500000);
    #endif

    if (sb16)
        change_music(NULL, 1);

    clear_screen();
    memcpy(palette, pal_ftris, 768);
    setpal(palette);
    affiche_volume(VSCR_AUTRES+4);
    copy_v2s(VSCR_AUTRES+4);
}
