/* ========================================================================== *
 *                                                                            *
 *              ADD_EXE.PAS (c) 06/03/97 for Dos       by FlashCode           *
 *              ADD_EXE.C   (c) 13/06/99 for Dos/Linux by FlashCode           *
 *                                                                            *
 * ========================================================================== *

   ==== This program is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== This program is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with this program; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/13

2001/09/01: FlashCode:
    - ajout de la licence
*/


#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#ifdef MSDOS
    #include <ctype.h>
#endif

#define NOM_TEMP    "temp_exe.tmp"

#define PASCAL_UNIT 1
#define C_HEADER    2


typedef struct
{
    unsigned char   nom[128];
    long            taille;
} t_fichier;

FILE            *link, *exe, *dat, *temp;
unsigned char   nom_exe[256], nom_link[256];
int             source, noadd, nb_dat;
unsigned char   buffer[50000];
t_fichier       fichier[50];
int             nb_lus, nb_ecrits;
int             quiet, verbose;
long            taille_exe_originale, taille_exe_finale;

/* ========================================================================== */

/*
 * aide: affiche l'aide et eventuellement un message d'erreur
 */

void aide(unsigned char *message, ...)
{
    unsigned char   buf[1000];
    va_list         argptr;

    if (message != NULL)
    {
        va_start(argptr, message);
        vsprintf(buf, message, argptr);
        va_end(argptr);
        fprintf(stderr, "add_exe: %s\n", buf);
    }
    printf("\nADD_EXE  (c) 1999/06/13 by FlashCode (Sebastien Helleu)\n\n");
    printf("  ADD_EXE link_file [-p|-c] [-a] [-q|-v]\n\n");
    printf("     link_file   file used to link data to exe (see below) [.LNK]\n");
    printf("         -p      produces 'data_exe.pas' (Pascal unit)\n");
    printf("         -c      produces 'data_exe.h' (C header)\n");
    printf("         -a      doesn't add files (only writes Pascal unit or C header)\n");
    printf("         -q      quiet\n");
    printf("         -v      verbose\n");
    printf("       -license  displays program license\n\n");
    printf("Link file :\n");
    printf("1st line is the name of the executable.\n");
    printf("Other lines are names of data files.\n\n");
    exit(1);
}

/*
 * affiche_licence: affiche la licence de ADD_EXE
 */

void affiche_licence()
{
    printf("\nADD_EXE  (c) Copyright 1999,2000,2001 by FlashCode (Sebastien Helleu)\n\n");
    printf("This program is free software; you can redistribute it and/or modify\n");
    printf("it under the terms of the GNU General Public License as published by\n");
    printf("the Free Software Foundation; either version 2 of the License, or\n");
    printf("(at your option) any later version.\n");
    printf("\n");
    printf("This program is distributed in the hope that it will be useful,\n");
    printf("but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
    printf("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
    printf("GNU General Public License for more details.\n");
    printf("\n");
    printf("You should have received a copy of the GNU General Public License\n");
    printf("along with this program; if not, write to the Free Software\n");
    printf("Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n\n");
    exit(0);
}


/*
 * erreur: affiche un message d'erreur
 */

void erreur(unsigned char *message, ...)
{
    unsigned char   buf[1000];
    va_list         argptr;

    va_start(argptr, message);
    vsprintf(buf, message, argptr);
    va_end(argptr);
    fprintf(stderr, "add_exe: ***ERROR*** %s", buf);
    exit(1);
}

/*
 * traite_params: traite les parametres de la ligne de commande
 */

void traite_params(int argc, char *argv[])
{
    int     i;

    source = 0; noadd = 0; quiet = 0; verbose = 0;
    if (argc == 1)
        aide("expected parameter");
    for (i = 1; i < argc; i++)
        if (argv[i][0] == '-')
        {
            if (strcasecmp(argv[i], "-license") == 0)
                affiche_licence();
            if (strlen(argv[i]) > 2)
                aide("unkown paramater: %s", argv[i]);
            switch (argv[i][1])
            {
                case 'p':
                case 'P':
                    source = PASCAL_UNIT; break;
                case 'c':
                case 'C':
                    source = C_HEADER; break;
                case 'a':
                case 'A':
                    noadd = 1; break;
                case 'q':
                case 'Q':
                    quiet = 1; break;
                case 'v':
                case 'V':
                    verbose = 1; break;
                default:
                    aide("unkown paramater: %s", argv[i]);
            }
        }
        else
            strcpy(nom_link, argv[i]);
    if ( (noadd) && (source == 0) )
        aide("nothing to do !");
    if ( (quiet) && (verbose) )
        aide("incompatible parameters - quiet & verbose");
    if (strchr(nom_link, '.') == NULL)
        strcat(nom_link, ".lnk");
}

/*
 * supprime_rc_final: supprime le Retour Chariot final d'une chaine
 */

void supprime_rc_final(unsigned char *chaine)
{
    unsigned char   *pos_rc;

    #ifdef MSDOS
    pos_rc = strchr(chaine, 13);
    if (pos_rc != NULL)
        pos_rc[0] = '\0';
    #endif
    pos_rc = strchr(chaine, 10);
    if (pos_rc != NULL)
        pos_rc[0] = '\0';
}

/*
 * lit_fichier_lnk: lit le fichier .LNK
 */

void lit_fichier_lnk()
{
    FILE            *f;

    if ( (link = fopen(nom_link, "rt")) == NULL)
        erreur("opening link_file '%s'", nom_link);
    if (fgets(nom_exe, 255, link) == NULL)
    {
        fclose(link);
        erreur("invalid link_file '%s'", nom_link);
    }
    #ifdef MSDOS
    if (strchr(nom_exe, '.') == NULL)
        strcpy(&nom_exe[strlen(nom_exe)], ".exe");
    #endif
    supprime_rc_final(nom_exe);
    if (feof(link) != 0)
    {
        fclose(link);
        erreur("invalid link_file '%s'", nom_link);
    }
    nb_dat = 0;
    do
    {
        fgets(fichier[nb_dat].nom, 127, link);
        if (!feof(link))
        {
            #ifdef MSDOS
            if (fichier[nb_dat].nom[0] == 13)
                strcpy(fichier[nb_dat].nom, fichier[nb_dat].nom+1);
            #endif
            supprime_rc_final(fichier[nb_dat].nom);
            if (fichier[nb_dat].nom[0] != '#')
            {
                if ( (f = fopen(fichier[nb_dat].nom, "rb")) == NULL)
                {
                    fclose(link);
                    erreur("file '%s' does not exist !", fichier[nb_dat].nom);
                }
                fseek(f, 0L, SEEK_END);
                fichier[nb_dat].taille = ftell(f);
                #ifdef MSDOS
                /*for (i = 0; i < strlen(fichier[nb_dat].nom); i++)
                    fichier[nb_dat].nom[i] = toupper(fichier[nb_dat].nom[i]);*/
                #endif
                fclose(f);
                nb_dat++;
            }
        }
    } while (feof(link) == 0);
    fclose(link);
}

/*
 * prepare_fichier_temp: ouvre le fichier temporaire en ecriture
 */

void prepare_fichier_temp()
{
    if ( (exe = fopen(nom_exe, "rb")) == NULL)
        erreur("opening file '%s'", nom_exe);
    if ( (temp = fopen(NOM_TEMP, "rb")) != NULL)
    {
        fclose(exe);
        erreur("file '" NOM_TEMP "' already exists !");
    }
    if ( (temp = fopen(NOM_TEMP, "wb")) == NULL)
    {
        fclose(exe);
        erreur("writing file '" NOM_TEMP "'");
    }
}

/*
 * lit_fichier_exe: lit le fichier executable et l'ecrit dans le temporaire
 */

void lit_fichier_exe()
{
    taille_exe_originale = 0;
    do
    {
        nb_lus = fread(buffer, 1, 50000, exe);
        if (nb_lus == 0)
            nb_ecrits = 0;
        else
            nb_ecrits = fwrite(buffer, 1, nb_lus, temp);
        taille_exe_originale += nb_ecrits;
    } while ( (nb_lus != 0) && (nb_lus == nb_ecrits) );
    if (nb_lus != nb_ecrits)
    {
        fclose(exe);
        fclose(temp);
        erreur("writing file '" NOM_TEMP "'");
    }
    taille_exe_finale = taille_exe_originale;
}

/*
 * ajoute_fichier: ajoute un fichier dans le fichier temporaire
 */

void ajoute_fichier(int no)
{
    if ( (dat = fopen(fichier[no].nom, "rb")) == NULL)
    {
        fclose(exe); fclose(temp);
        erreur("opening data file '%s'", fichier[no].nom);
    }
    do
    {
        nb_lus = fread(buffer, 1, 50000, dat);
        if (nb_lus == 0)
            nb_ecrits = 0;
        else
            nb_ecrits = fwrite(buffer, 1, nb_lus, temp);
        taille_exe_finale += nb_ecrits;
    } while ( (nb_lus != 0) && (nb_lus == nb_ecrits) );
    if (nb_lus != nb_ecrits)
    {
        fclose(exe); fclose(dat); fclose(temp);
        erreur("writing file '" NOM_TEMP "'");
    }
    fclose(dat);
}

/*
 * taille_totale: renvoie la taille totale des fichiers ajoutee jusqu'au numero no (inclus)
 */

long taille_totale(int no)
{
    int     i;
    long    res;

    res = 0;
    for (i = no; i <= nb_dat; i++)
        res += fichier[i].taille;
    return res;
}

/*
 * get_ptr_nom_sans_chemin: renvoie un pointeur vers le debut du nom de fichier
 *                          (saute le chemin s'il y en a un)
 */

unsigned char *get_ptr_nom_sans_chemin(unsigned char *nom_complet)
{
    unsigned char   *pos;

    pos = strrchr(nom_complet, '/');
    if (pos != NULL)
        return pos+1;
    pos = strrchr(nom_complet, '\\');
    if (pos != NULL)
        return pos+1;
    return nom_complet;
}

/*
 * ecrit_pascal: ecrit l'unite en Pascal
 */

void ecrit_pascal()
{
    int             i;
    FILE            *f;
    unsigned char   chaine[256];

    if ( (f = fopen("data_exe.pas", "wt")) == NULL)
        erreur("creating file 'data_exe.pas'");
    fputs("UNIT Data_EXE\n\n", f);
    fputs("INTERFACE\n\n", f);
    fputs("TYPE\n", f);
    fputs("  T_Data_File_Exe = RECORD\n", f);
    fputs("                      Nom : STRING[12];\n", f);
    fputs("                      Posit : LONGINT;\n", f);
    fputs("                      Taille : LONGINT\n", f);
    fputs("                    END;\n\n", f);
    fputs("CONST\n", f);
    sprintf(chaine, "  Nb_fich_dat = %d;\n", nb_dat);
    fputs(chaine, f);
    sprintf(chaine, "  Pos_file_exe : ARRAY[1..%d] OF T_Data_File_Exe =\n", nb_dat);
    fputs(chaine, f);
    fputs("    (", f);
    for (i = 0; i < nb_dat; i++)
    {
        if (i > 0)
            fputs("     ", f);
        sprintf(chaine, "(Nom:'%s'; Posit:%ld; Taille:%ld",
            get_ptr_nom_sans_chemin(fichier[i].nom),
            taille_totale(i), fichier[i].taille);
        fputs(chaine, f);
        if (i == nb_dat-1)
            fputs("));\n", f);
        else
            fputs("),\n", f);
    }
    fputs("\n  FUNCTION Position_fichier(Nom_fichier : STRING) : LONGINT;", f);
    fputs("  FUNCTION Taille_fichier(Nom_fichier : STRING) : LONGINT;\n\n", f);
    fputs("IMPLEMENTATION\n\n", f);
    fputs("  FUNCTION Position_fichier(Nom_fichier : STRING) : LONGINT;\n", f);
    fputs("    VAR\n", f);
    fputs("      i : BYTE;\n", f);
    fputs("    BEGIN\n", f);
    fputs("      FOR i:=1 TO Length(Nom_fichier) DO Nom_fichier[i]:=UpCase(Nom_fichier[i]);\n", f);
    fputs("      FOR i:=Nb_fich_dat DOWNTO 1 DO\n", f);
    fputs("        IF Pos_file_exe[i].Nom=Nom_fichier THEN\n", f);
    fputs("          BEGIN Position_fichier:=Pos_file_exe[i].Posit; Exit END\n", f);
    fputs("    END;\n\n", f);
    fputs("  FUNCTION Taille_fichier(Nom_fichier : STRING) : LONGINT;\n", f);
    fputs("    VAR\n", f);
    fputs("      i : BYTE;\n", f);
    fputs("    BEGIN\n", f);
    fputs("      FOR i:=1 TO Length(Nom_fichier) DO Nom_fichier[i]:=UpCase(Nom_fichier[i]);\n", f);
    fputs("      FOR i:=1 TO nb_fich_dat DO\n", f);
    fputs("        IF Pos_file_exe[i].Nom=Nom_fichier THEN\n", f);
    fputs("          BEGIN Taille_fichier:=Pos_file_exe[i].Taille; Exit END\n", f);
    fputs("    END;\n\n", f);
    fputs("BEGIN\n", f);
    fputs("END.", f);
    fclose(f);
}

/*
 * ecrit_C: ecrit l'en-tete C
 */

void ecrit_C()
{
    int             i;
    FILE            *f;
    unsigned char   chaine[256];

    /* ecriture de data_exe.h */
    if ( (f = fopen("data_exe.h", "wt")) == NULL)
        erreur("creating file 'data_exe.h'");
    fputs("/* DATA_EXE header file for 'data_exe.c' */\n\n", f);
    fputs("#ifndef __DATA_EXE__\n", f);
    fputs("#define __DATA_EXE__\n\n", f);
    fputs("#define DATA_EXE\n\n", f);
    fputs("struct T_data_file_exe\n", f);
    fputs("{\n", f);
    fputs("    char *nom;\n", f);
    fputs("    long position;\n", f);
    fputs("    long taille;\n", f);
    fputs("};\n\n", f);
    sprintf(chaine, "#define NB_FICH_DAT %d\n\n", nb_dat);
    fputs(chaine, f);
    fputs("extern long position_fichier(char *);\n", f);
    fputs("extern long taille_fichier(char *);\n", f);
    fputs("#endif", f);
    fclose(f);

    /* ecriture de data_exe.c */
    if ( (f = fopen("data_exe.c", "wt")) == NULL)
        erreur("creating file 'data_exe.c'");
    #ifdef MSDOS
    sprintf(chaine, "/* DATA_EXE - C file for Dos/Windows executable '%s' */\n\n", nom_exe);
    #else
    sprintf(chaine, "/* DATA_EXE - C file for Linux executable '%s' */\n\n", nom_exe);
    #endif
    fputs(chaine, f);
    fputs("#include \"data_exe.h\"\n\n", f);
    fputs("struct T_data_file_exe file_exe[NB_FICH_DAT]=\n", f);
    fputs("{", f);
    for (i = 0; i < nb_dat; i++)
    {
        if (i > 0) fputs(" ", f);
        sprintf(chaine, "{\"%s\", %ld, %ld",
            get_ptr_nom_sans_chemin(fichier[i].nom),
            taille_totale(i), fichier[i].taille);
        fputs(chaine, f);
        if (i == nb_dat-1)
            fputs("}};\n", f);
        else
            fputs("},\n", f);
    }
    fputs("\nlong position_fichier(char *nom_fichier)\n", f);
    fputs("{\n", f);
    fputs("    int i = 0;\n\n", f);
    fputs("    for (i = NB_FICH_DAT-1; i >= 0; i--)\n", f);
    fputs("        if (strcasecmp(file_exe[i].nom, nom_fichier) == 0)\n", f);
    fputs("            return file_exe[i].position;\n", f);
    fputs("    return 0;  /* error: file not found ! */\n", f);
    fputs("}\n\n", f);
    fputs("long taille_fichier(char *nom_fichier)\n", f);
    fputs("{\n", f);
    fputs("    int i = 0;\n\n", f);
    fputs("    for (i = 0; i < NB_FICH_DAT; i++)\n", f);
    fputs("        if (strcasecmp(file_exe[i].nom, nom_fichier) == 0)\n", f);
    fputs("            return file_exe[i].taille;\n", f);
    fputs("    return 0;  /* error: file not found ! */\n", f);
    fputs("}\n\n", f);
    fclose(f);
}

int main(int argc, char *argv[])
{
    unsigned char   i;

    traite_params(argc, argv);

    if (verbose)
        printf("add_exe: reading link_file\n");
    lit_fichier_lnk();
    if (!noadd)
    {
        if (verbose)
            printf("add_exe: opening files\n");
        prepare_fichier_temp();
        if (verbose)
            printf("add_exe: reading %s\n", nom_exe);
        lit_fichier_exe();
        for (i = 0; i < nb_dat; i++)
        {
            if (verbose)
                printf("add_exe: adding file %s (%ld bytes)\n",
                    fichier[i].nom, fichier[i].taille);
            ajoute_fichier(i);
        }
        fclose(exe); fclose(temp);
        if (remove(nom_exe) != 0)
            erreur("unable to delete file '%s'", nom_exe);
        if (rename(NOM_TEMP, nom_exe) != 0)
            erreur("unable to rename file '" NOM_TEMP "' as '%s'", nom_exe);
    }
    if (source != 0)
    {
        switch (source)
        {
            case 1:
                if (verbose)
                    printf("add_exe: writing Pascal unit (data_exe.pas)\n");
                ecrit_pascal();
                break;
            case 2:
                if (verbose)
                    printf("add_exe: writing C header (data_exe.h & .c)\n");
                ecrit_C();
                break;
        }
    }
    /*printf("\n--> OK.\n");*/
    if (!quiet)
    {
        printf("add_exe: ");
        switch (source)
        {
            case PASCAL_UNIT: printf("Pascal unit created (data_exe.pas), "); break;
            case C_HEADER   : printf("C header created (data_exe.h & .c), "); break;
        }
        if (noadd)
            printf("no file added\n");
        else
            printf("%d files added (%ld bytes), executable size: %ld --> %ld\n",
                nb_dat, taille_exe_finale-taille_exe_originale,
                taille_exe_originale, taille_exe_finale);
    }
    return 0;
}
