/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== ftris.h: header principal de FlashTris
   ====

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/


#ifndef __FTRIS_FTRIS__
#define __FTRIS_FTRIS__

#ifdef MSDOS
    #include <dpmi.h>
#else
    #ifndef CYGWIN
        #include <X11/Xlib.h>
    #endif
#endif

#include "data_exe.h"
#include "game.h"
#include "video.h"


#define DATE_FR         "06/09/2001"
#define DATE_EN         "2001/09/06"
#define DATE_FR_LONG    "06 sep 2001"
#define DATE_EN_LONG    "Sep 06 2001"
#define VERSION         "v0.30 alpha"
#define EMAIL           "flashcode@free.fr"
#define SITE_WEB        "http://flashcode.free.fr"
#define REPORT_BUG      ("This is a BUG !\nPlease report complete error message to: " EMAIL "\nThanks for your help.\n")

#define DATE_DEBUT_FR   "21/06/1999"
#define DATE_DEBUT_EN   "06/21/1999"

#define VERSION_CONFIG      "cfg-v0.28 alpha "
#define SIGNATURE_CONFIG    ("FlashTris Config << DO NOT EDIT ! >> " VERSION_CONFIG)

#ifdef MSDOS
    #define OS          "Dos/Win_3.x,9x,2000"
    #define AUTRES_OS   "Linux/X-Window/Unix"
    #define OS_CONFIG   "Dos/Win"
#else
    #define OS          "Linux/X-Window/Unix"
    #define AUTRES_OS   "Dos/Win_3.x,9x,2000"
    #define OS_CONFIG   "!Linux!"
#endif

#ifdef DATA_EXE
    #define PATH_SAMPLES    ""
    #define PATH_GFX        ""
    #define PATH_MOD        ""
#else
    #ifdef MSDOS
        #define PATH_GFX        ".\\gfx\\"
        #define PATH_MUSIC      ".\\music\\"
    #else
        #define PATH_GFX        "./gfx/"
        #define PATH_MUSIC      "./music/"
    #endif
#endif

#define NB_FONDS        10

#define NB_MUSIC        17

#define NO_MUSIC        -1
#define MUSIC_RANDOM    0
#define MUSIC1          1

/* pour les erreurs (ftris_error()) : */

#define MSG_WARNING     0
#define MSG_ERROR       1

#define NO_BUG          0
#define BUG             1

#define NO_CLOSE_SB16   0
#define CLOSE_SB16      1

#define CONTINUE        0
#define STOP_PROG       1
#define STOP_PROG_GRAVE 255


extern unsigned char    argv0[256];

extern unsigned char    *nom_fond[NB_FONDS];

extern int              no_sound;
extern int              silencieux;

extern t_sprite         titre_flashtris;
extern t_sprite         titre_flashtris_blanc;
extern t_sprite         copyright;
extern t_sprite         grillage;
extern t_sprite         grillage_clair;

extern t_sprite         case_vide[2];
extern t_sprite         case_cochee[6];

extern t_sprite         brique[NB_TC][8];
/*extern t_sprite         brique_menu[NB_TC][7];*/
extern t_sprite         explosion[NB_TC];
extern t_sprite         bombe[NB_TC][2];
extern t_sprite         tube[15][7];

extern int              sb16;
extern int              force_port;
extern int              force_irq;
extern int              music_menu;
extern int              music_jeu;
extern int              music_jouee;
extern int              sons;
extern int              sons_menu;
extern unsigned char    *nom_music[NB_MUSIC+1];


extern void ftris_error(int, int, int, int, unsigned char *chaine, ...);
extern void *ftris_malloc(int, unsigned char *);

#ifdef MSDOS
extern void detourne_interruption(int, int, __dpmi_paddr *, _go32_dpmi_seginfo *);
extern void restaure_interruption(int, __dpmi_paddr *, _go32_dpmi_seginfo *);
#endif

extern int  ftris_detect_sb16();
extern void close_sb16();

extern int ftris_loadmodule(unsigned char *, int);
extern int ftris_loadsample(unsigned char *, int);
extern void ftris_vide_samples();
extern void ftris_charge_samples(int);
extern void stop_music();
extern void change_music(unsigned char *, int);
#endif
