/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== game.h: header pour game.c
   ====

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/


#ifndef __FTRIS_GAME__
#define __FTRIS_GAME__

#define GAME_CLASSIC        0
#define GAME_CHALLENGE      1
#define GAME_STAR           2

#define NBJ_MAX             100
#define NET_NBJ_MAX         200

#define NIVEAU_MAX          14

#define AIRE_NORMALE        0
#define AIRE_LARGE          1

#define ACCELER_FALL        0
#define ACCELER_FAST        1
#define ACCELER_SLOW        2
#define ACCELER_V_SLOW      3

#define NB_FORMES_AV        500

#define SOUND_OFF           0
#define SOUND_SPEAKER       1
#define SOUND_SB16          2

#define NET_TCPIP           0
#define NET_IPX             1
#define NET_MODEM           2
#define NET_INTERNET        3

#define NB_LIG_CHANGE_MUSIC 100

/*#define MODE_COOP         0*/
/*#define MODE_VS           1*/

#define NB_FORMES           (7+10+1)

#define TC_MIN              1
#define TC_MAX              8
#define NB_TC               (TC_MAX-TC_MIN+1)

#define PIECE_BOMBE         1

#define ETAT_X_MAX          500
#define ETAT_Y_MAX          50

#define ETAT_PIECE_BONUS    99

#define SON_EXPLOSION_TETRIS    playsample(5, 36, 200, 63)
#define SON_EXPLOSION           playsample(4, 35, 150, 63)

#define COUL_1_WINNER       15
#define COUL_2_WINNER       22

typedef struct
{
    int             p_forme;        /* forme de la piece                                   */
    unsigned char   p_couleur;      /* couleur de la piece                                 */
    int             p_taille;       /* taille d'un carre de la piece en pixels             */
    int             p_x, p_y;       /* position de la piece                                */
                                    /* (coordonnees relatives en carre dans l'aire de jeu) */
    int             p_bonus;        /* = 1 si la piece est une piece bonus (bombe, ...)    */
} t_piece;

typedef struct
{
    unsigned char   hs_nom[18];
    int             hs_nblignes;
    int             hs_nblig[4];
    int             hs_score;
    int             hs_secondes;
} t_high_score;

typedef struct
{
    int             c_nb_lignes;
    int             c_temps_limite;
} t_challenge;

typedef struct
{
    int             nbj, nbp, nbc;
    int             nb_perdus;
    unsigned long   adresse;
    int             port;
    unsigned char   net_nom[11];
    /*  a completer !!!!!!!! */
} t_PC_net;

extern int              X_Win_couleur_piece[NB_FORMES];
extern int              couleur_piece[NB_FORMES];

extern unsigned char    touche[10][10][4];

extern int              x_inc[16], y_inc[16];

extern int              couleur_cadre[3];

extern int              y_carres_lignes[NBJ_MAX][4];

extern int              y_texte_ready[4];
extern int              coul_texte_ready[4][3];

extern int              game_mode;
extern int              game_team;
extern int              nbp;
extern int              nbc;
extern int              nbj;
extern int              nbx;
extern int              nby;
extern int              ordi[NBJ_MAX];
extern int              nb_PC_net;
extern t_PC_net         PC_net[NET_NBJ_MAX];
extern int              numero_PC_net;
extern int              bonus[NBJ_MAX];

extern int              descend_cptr[NBJ_MAX];
extern int              descend[NBJ_MAX];
extern int              touche_cptr[NBJ_MAX];
extern int              rotation_cptr[NBJ_MAX];

extern int              doit_remonter[NBJ_MAX];

extern signed char      etat[ETAT_Y_MAX][ETAT_X_MAX];

extern int              x_deb[NBJ_MAX], x_fin[NBJ_MAX];
extern int              y_deb[NBJ_MAX], y_fin[NBJ_MAX];
extern int              x_next[NBJ_MAX], y_next[NBJ_MAX];
extern int              x_next2[NBJ_MAX], y_next2[NBJ_MAX];

extern int              x_min[NBJ_MAX], x_max[NBJ_MAX];
extern int              y_min[NBJ_MAX], y_max[NBJ_MAX];

extern int              x_time, y_time;

extern t_piece          piece[NBJ_MAX];
extern int              forme_suivante[NBJ_MAX];
extern t_piece          next_piece[NBJ_MAX];
extern t_piece          next_piece2[NBJ_MAX];

extern int              forme_avance[NB_FORMES_AV];
extern int              numero_forme[NBJ_MAX];

extern int              difficulte;
extern int              same_pieces;
extern int              eccentric;
extern int              hauteur_ini;
extern int              time_limite;
extern int              cptr_time;
extern int              view_next;
extern int              stats;
extern int              acceler;
extern int              tc;
extern int              tc_stats;
extern int              tc_next;
extern int              fond_jeu;
extern int              bonus_level;
extern int              status_jeu;
extern int              window_msg;
extern int              cheat;
extern int              aire_de_jeu;
extern int              nbj_team[3];
extern int              team[NBJ_MAX];

extern int              en_jeu;
extern int              en_pause;

extern int              niveau;

extern int              image_bombe;

#ifdef MSDOS
extern int              compteur_usleep_dos;
#endif

/* config : */
extern int  get_game_team();
extern int  get_hauteur_ini();
extern int  get_stats();
extern int  get_time_limite();
extern int  get_window_msg();

/* timer : */
extern void nouveau_timer();
extern void detourne_int_timer();
extern void restaure_int_timer();

/* affichage : */
extern void calcule_pos_joueurs();
extern void dessine_image_jeu(int, int, int, int, int);
extern void init_aires_de_jeu();
extern void init_jeu();
extern void game_write_xy_s_c(int, int, int, int, int, int, unsigned char *, ...);
extern void game_write_xy_s_c_o(int, int, int, int, int, int, int, unsigned char *, ...);
extern void ajoute_msg(int, int, unsigned char *, ...);
extern void efface_msgs(int);
extern void affiche_nombre_lignes(int);
extern void efface_nombre_lignes(int);
extern void affiche_piece(int, int, t_piece *);
extern void redessine_aire_jeu(int);

/* jeu : */
extern int  choisit_piece_hasard();
extern void verifie_gagne_perdu();
extern void joueur_ou_team_perd(int);
extern void retourne_piece(int, t_piece *);
extern void etats_negatifs(int, t_piece *);
extern void etats_negatifs_team(int);
extern void etats_positifs(int, t_piece *);
extern void etats_positifs_team(int);
extern void annule_etats(int, t_piece *);
extern void annule_etats_team(int);
extern int  peut_descendre(int, t_piece *);
extern void nouvelle_piece(int, int);
extern void explosion_ligne(int, int);
extern void boucle_jeu();

#endif
