/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== menu.h: header pour menu.c
   ====

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/


#ifndef __FTRIS_MENU__
#define __FTRIS_MENU__

#include "video.h"

#define MENU_0_0_START          0
#define MENU_0_0_RESUME         1
#define MENU_0_0_ABOUT          2
#define MENU_0_0_HELP           3
#define MENU_0_0_ADVANCED       4
#define MENU_0_0_QUIT           5

#define MENU_0_1_LANGAGE        0
#define MENU_0_1_KEYBOARD       1
#define MENU_0_1_PIPES          2
#define MENU_0_1_BACKGROUND     3
#define MENU_0_1_BURNING        4
#define MENU_0_1_SCROLL         5
#define MENU_0_1_BRIK_COPYRIGHT 6
#define MENU_0_1_PIXELS         7
#define MENU_0_1_MUSIC_BARS     8
#define MENU_0_1_BUBBLES        9
#define MENU_0_1_SOUNDS         10
#define MENU_0_1_RESERVED1      11
#define MENU_0_1_RESERVED2      12
#define MENU_0_1_RESERVED3      13
#define MENU_0_1_RETURN         14

#define MENU_1_0_GAME           0
#define MENU_1_0_TEAM           1
#define MENU_1_0_PLAYERS        2
#define MENU_1_0_F_BOTS         3
#define MENU_1_0_BOTS_LEVEL     4
#define MENU_1_0_SAME_PIECES    5
#define MENU_1_0_HANDICAP       6
#define MENU_1_0_STATS          7
#define MENU_1_0_TIME           8
#define MENU_1_0_VIEW_NEXT      9
#define MENU_1_0_BONUS_LEVELS   10
#define MENU_1_0_ADVANCED       11

#define MENU_1_1_ECCENTRIC      0
#define MENU_1_1_STATUS         1
#define MENU_1_1_WINDOW_MSG     2
#define MENU_1_1_ACCELER        3
#define MENU_1_1_GAME_AREA      4
#define MENU_1_1_TEAM1          5
#define MENU_1_1_TEAM2          6
#define MENU_1_1_BACKGROUND     7
#define MENU_1_1_CHEAT          8
#define MENU_1_1_PIECES_EDITOR  9
#define MENU_1_1_REDEFINE_KEYS  10
#define MENU_1_1_RETURN         11

#define MENU_2_0_MUSIC_MENU     0
#define MENU_2_0_MUSIC_GAME     1
#define MENU_2_0_SOUND_FX       2

#define MENU_2_1_DETECT_SB16    0
#define MENU_2_1_SB16_PORT      1
#define MENU_2_1_SB16_IRQ       2

#define MENU_3_0_CREATE_GAME    0
#define MENU_3_0_JOIN_GAME      1
#define MENU_3_0_CANCEL_NET     2
#define MENU_3_0_NET_NAME       3
#define MENU_3_0_NET_TYPE       4
#define MENU_3_0_NET_SERVER     5
#define MENU_3_0_NBJ_MAX        6
#define MENU_3_0_ALLOW_BOTS     7
#define MENU_3_0_BONUS_LEVELS   8
#define MENU_3_0_SAME_PIECES    9
#define MENU_3_0_ADVANCED       10

#define MENU_3_1_VIEW_OTHER     0
#define MENU_3_1_CHAT           1
#define MENU_3_1_TEAMS          2
#define MENU_3_1_SOCKET         3
#define MENU_3_1_MOUSTIK_STYLE  4
#define MENU_3_1_CDM_STYLE      5
#define MENU_3_1_RESERVED1      6
#define MENU_3_1_RESERVED2      7
#define MENU_3_1_RESERVED3      8
#define MENU_3_1_RESERVED4      9
#define MENU_3_1_RETURN         10

#define ANGLAIS     0
#define FRANCAIS    1

#define QWERTY      0
#define AZERTY      1

#define NB_COUL_TUBES       8

#define COUL_FLAMES     176

#define COUL_OPTMENU_ACT_NOM        98
#define COUL_OPTMENU_ACT_OMBRE_NOM  107
#define COUL_OPTMENU_ACT_LIBELLE    121
#define COUL_OPTMENU_ACT_OMBRE_LIB  125
#define COUL_MENU_ACT_NOM           73
#define COUL_MENU_ACT_OMBRE_NOM     77
#define COUL_MENU_ACT_LIBELLE       132
#define COUL_MENU_ACT_OMBRE_LIB     135
#define COUL_OPT_INACT_NOM          78
#define COUL_OPT_INACT_OMBRE_NOM    28
#define COUL_OPT_INACT_LIBELLE      135
#define COUL_OPT_INACT_OMBRE_LIB    28

#define COUL_OPT_GRISEE_NOM         26
#define COUL_OPT_GRISEE_OMBRE_NOM   30
#define COUL_OPT_GRISEE_LIBELLE     26
#define COUL_OPT_GRISEE_OMBRE_LIB   30

/* couleurs des libelles dans la liste de choix */
#define COUL_OPTLISTE_ACT_LIB       73
#define COUL_OPTLISTE_ACT_OMBRE     77
#define COUL_OPTLISTE_INACT_LIB     121
#define COUL_OPTLISTE_INACT_OMBRE   125

/* nombre maxi de choix dans une liste de choix (nombre maxi de valeurs pour */
/* une option)                                                               */
#define NB_CHOIX_MAX        50

/* nombre maxi de lignes de texte par dessus la preview du jeu */
#define MAX_TEXTE_PREVIEW   300

#define X_VU_METRES     120
#define Y_VU_METRES     170

#define COUL_TEXTE_BOUTON 70

/*#define X_VOLUME        33 */
#define X_VOLUME        119
#define Y_VOLUME        189
/* mini 5 */
#define HAUTEUR_VOLUME  5

#ifdef MSDOS
    #define INC_VOLUME_VITE     3
#else
    #define INC_VOLUME_VITE     5
#endif

#define NB_PIXELS_MAX       120


#define SON_BOUGE_BARRE                 playsample(4, 35, 400, 63)
#define SON_BOUGE_LISTE_CHOIX           playsample(4, 35, 700, 63)
#define SON_OUVRE_LISTE_CHOIX           playsample(4, 35, 200, 63)
#define SON_FERME_LISTE_CHOIX           SON_OUVRE_LISTE_CHOIX
#define SON_MODIFIE_OPTION              playsample(4, 36, 200, 63)
#define SON_IMPOSSIBLE_MODIFIE_OPTION   playsample(4, 36, 400, 63);
#define SON_CHANGE_MENU                 playsample(4, 37, 400+(rand()%200), 63)
#define SON_DEBUT_EDITION_CHAINE        playsample(4, 35, 200, 63)
#define SON_FIN_EDITION_CHAINE          SON_DEBUT_EDITION_CHAINE
#define SON_CYBER                       playsample(5, 39, 400, 63)

#define BULLE_AIDE_OPTION   0
#define BULLE_INFO_CHOIX    1
#define DUREE_BULLE_AIDE    100
#define DUREE_BULLE_INFO    70

#define DUREE_LISTE_CHOIX   300
#define LISTE_CHOIX_NB_MAX  20

#define SCROLLTXT_X         103
#define SCROLLTXT_Y         150
#define SCROLLTXT_OFS       (SCROLLTXT_X+320*SCROLLTXT_Y)
#define SCROLLTXT_LARGEUR   120

#define BRIK_NB_LIG     11
#define BRIK_HAUT_LIG   (5*2+4)
#define BRIK_IMAGE_NBX  (126)
#define BRIK_IMAGE_NBY  (BRIK_NB_LIG*BRIK_HAUT_LIG)
#define BRIK_X          97
#define BRIK_Y          158
#define BRIK_NBX_AFF    (BRIK_IMAGE_NBX)
#define BRIK_NBY_AFF    (10)


typedef struct
{
    unsigned char   *o_nom;             /* NULL = fin                                                   */
    unsigned char   *o_bulle;           /* NULL = pas de bulle                                          */
    int             *o_valeur_int;      /* NULL pour une chaine                                         */
    unsigned char   *o_valeur_chaine;   /* NULL pour un entier                                          */
    int             o_mini;             /* pour un entier: valeur mini                                  */
                                        /* pour un bouton: largeur (0=auto)                             */
    int             o_maxi;             /* pour un entier: valeur maxi                                  */
                                        /* pour un bouton: hauteur (0=auto)                             */
                                        /* pour une chaine: longueur maxi                               */
    unsigned char   **o_ptr_libelle;    /* si <> NULL alors l'entier designe un element de ce tableau   */
                                        /* pour affichage                                               */
    unsigned char   **o_ptr_bulle;      /* si <> NULL alors des bulles peuvent s'afficher pour l'option */
    void            *o_fonction_verifie;/* fonction appelee pour verifier un changement de valeur       */
    void            *o_fonction_grise;  /* fonction pour griser/degriser un choix                       */
    int             o_choix_actif;      /* 0 si choix inaccessible (quand jeu en pause par exemple)     */
    int             o_actif_en_pause;   /* 0 si le choix devient inactif quand le jeu est en pause      */
} t_option;


extern int              quitte_flashtris;

extern unsigned char    pal_ftris[768];

extern int              langue;
extern int              clavier;

extern int              fond_menu;

extern int              tab_couleur_tubes[NB_COUL_TUBES];
extern int              couleur_tubes;

extern int              couleur_cases_cochees;

extern int              flam_x1, flam_y1, flam_x2, flam_y2, flam_largeur, flam_hauteur;
extern int              flam_taille_image, flam_coul, flam_nb_coul;
extern unsigned char    *flam_src, *flam_dest;
extern t_sprite         *flam_image, flam_a_afficher;
extern t_sprite         flam_copyright;
extern int              flam_affichees;
extern int              flam_affichables;

extern int              bulle_affichee;
extern int              bulle_cptr;
extern int              bulle_duree;
extern int              bulle_x1, bulle_y1, bulle_x2, bulle_y2;
extern t_sprite         bulle_fond;

extern int              compteur_palette;
extern int              compteur_clignote;

extern int              pos_menu, pos_advanced, pos_barre;
extern int              save_pos_barre[4][2], save_advanced[4];

extern int              titre_en_flames;
extern int              about_scrolling;
extern int              barres_samples;
extern int              bulles;
/*extern int              fast_preview;*/

extern int              barsmp_x[3][4];
extern int              barsmp_larg[3];
extern int              barsmp_haut[3];
extern int              barsmp_coul[3];

extern int              pos_musique;

extern int              pv_tc_piece;
extern int              pv_tc_next;
extern int              pv_tc_next2;
extern int              pv_larg_aire;
extern int              pv_haut_aire;
extern int              pv_x1[NBJ_MAX];
extern int              pv_y1[NBJ_MAX];
extern int              pv_cptr_tombe;

extern int              liste_choix;
extern int              liste_choix_cptr;
extern int              liste_choix_pos;
extern int              liste_choix_nb;
extern int              liste_choix_x1;
extern int              liste_choix_y1;
extern int              liste_choix_x2;
extern int              liste_choix_y2;
extern int              liste_choix_x[NB_CHOIX_MAX];
extern int              liste_choix_y[NB_CHOIX_MAX];
extern int              liste_choix_actif[NB_CHOIX_MAX];
extern unsigned char    *liste_choix_lib[NB_CHOIX_MAX];
extern t_sprite         liste_choix_fond;

extern int              aide_affichee;

extern int              pieces_editor;
extern int              editor_pos;
extern int              editor_piece[4];

extern int              redefine_keys;

extern int              edition_chaine;
extern int              edition_chaine_x1;
extern int              edition_chaine_y1;
extern int              edition_chaine_x2;
extern int              edition_chaine_y2;
extern int              edition_chaine_x_curseur;
extern unsigned char    edition_chaine_defaut[100];
extern unsigned char    edition_chaine_editee[100];
extern int              edition_chaine_max;
extern t_sprite         fond_edition;

extern int              pixel_nb;
extern int              pixel_nb_tab[6];
extern int              pixel_nb_a_afficher;
extern float            pixel_x[NB_PIXELS_MAX];
extern float            pixel_y[NB_PIXELS_MAX];
extern float            pixel_inc_x[NB_PIXELS_MAX];
extern float            pixel_inc_y[NB_PIXELS_MAX];
extern float            pixel_couleur[NB_PIXELS_MAX];
extern float            pixel_inc_coul[NB_PIXELS_MAX];
extern int              pixel_fond[NB_PIXELS_MAX];

extern t_option         *ptr_menus[4][2];

extern int              nb_options[4][2];
extern int              pos_option[4][2][15][2];
extern int              largeur_option[4][2][15];
extern int              largeur_option_reelle[4][2][15];

extern unsigned char    *texte_scrolling[2];
extern unsigned char    *image_scroll;
extern int              scrolltxt_x, scrolltxt_lx_image;
extern unsigned char    scrolltxt_coul[SCROLLTXT_LARGEUR];
extern int              scrolltxt_cptr;

extern int              brik_copyright;
extern unsigned char    *brik_data[2][BRIK_NB_LIG];
extern int              brik_coul[BRIK_NB_LIG];
extern int              brik_time[BRIK_NB_LIG];
extern unsigned char    *brik_image;
extern t_sprite         *brik_fond;
extern int              brik_cptr;
extern int              brik_no_lig;
extern int              brik_scroll_y;

extern t_option         *ptr_menus[4][2];


extern unsigned char *get_lib_music();
extern void menu_choix_avec_jeu();
extern void menu_choix_sans_jeu();
extern void grise_options_menu(int);
extern void affiche_pause_clignote();
extern void efface_pause_clignote();
extern void affiche_network_clignote();
extern void efface_network_clignote();
extern void ajoute_texte_preview(int, unsigned char *);
extern void ajoute_texte_preview_nbj();
extern void retire_texte_preview_derniere_ligne();
extern void retire_texte_preview_une_ligne(int);
extern void free_texte_preview();
extern void annule_reseau(int, int, int);
extern void start_game();
extern void resume_game();
extern void menu();
#endif
