/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== menu_tst.c: tests pour les valeurs du menu
   ====

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "ftris.h"
#include "menu_tst.h"
#include "menu.h"
#include "game.h"
#include "bonus.h"
#include "netftris.h"


int verifie_option(int (fonction)(), int new_value)
{
    return (*fonction)(new_value);
}

int grise_option(int (fonction)())
{
    return (*fonction)();
}

int grise_start_game()
{
    if ( (network)
        && ( (!net_master)
            || (nb_PC_net <= 1) ) )
    {
        if (ptr_menus[0][0][MENU_0_0_START].o_choix_actif)
        {
            ptr_menus[0][0][MENU_0_0_START].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[0][0][MENU_0_0_START].o_choix_actif)
        {
            ptr_menus[0][0][MENU_0_0_START].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_resume_game()
{
    if (!en_pause)
    {
        if (ptr_menus[0][0][MENU_0_0_RESUME].o_choix_actif)
        {
            ptr_menus[0][0][MENU_0_0_RESUME].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[0][0][MENU_0_0_RESUME].o_choix_actif)
        {
            ptr_menus[0][0][MENU_0_0_RESUME].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_about()
{
    if ( (network) && (!net_master) )
    {
        if (ptr_menus[0][0][MENU_0_0_ABOUT].o_choix_actif)
        {
            ptr_menus[0][0][MENU_0_0_ABOUT].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[0][0][MENU_0_0_ABOUT].o_choix_actif)
        {
            ptr_menus[0][0][MENU_0_0_ABOUT].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_help()
{
    if ( (network) && (!net_master) )
    {
        if (ptr_menus[0][0][MENU_0_0_HELP].o_choix_actif)
        {
            ptr_menus[0][0][MENU_0_0_HELP].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[0][0][MENU_0_0_HELP].o_choix_actif)
        {
            ptr_menus[0][0][MENU_0_0_HELP].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int verifie_game_mode(int new_game_mode)
{
    /*if ( (new_game_mode == GAME_COOP) && (nbp+nbc <= 1) )
        return 0;
    else*/
    if ( ( (network) && ( (new_game_mode == GAME_CHALLENGE) || (!net_master) ) )
        || ( (new_game_mode == GAME_CHALLENGE) && ( (nbc != 0) || (nbp != 1) ) ) )
        return 0;
    else
        return 1;
}

int grise_game_mode()
{
    if (network)
    {
        if (ptr_menus[1][0][MENU_1_0_GAME].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_GAME].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][0][MENU_1_0_GAME].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_GAME].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int verifie_game_team(int new_game_team)
{
    if ( (new_game_team) && (nbp+nbc <= 1) )
        return 0;
    else
        return 1;
}

int grise_game_team()
{
    if ( (network) || (nbp+nbc <= 1) )
    {
        if (ptr_menus[1][0][MENU_1_0_TEAM].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_TEAM].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][0][MENU_1_0_TEAM].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_TEAM].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int verifie_nbp(int new_nbp)
{
    /*if ( (get_game_team()) && (new_nbp+nbc <= 1) )
        return 0;
    else*/
        /* il doit y avoir au moins 1 joueur (humain ou ordi) */
        return (new_nbp+nbc > 0);
}

int grise_nbp()
{
    if ( (network) || (game_mode == GAME_CHALLENGE) )
    {
        if (ptr_menus[1][0][MENU_1_0_PLAYERS].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_PLAYERS].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][0][MENU_1_0_PLAYERS].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_PLAYERS].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int verifie_nbc(int new_nbc)
{
    /*if ( (get_game_team()) && (nbp+new_nbc <= 1) )
        return 0;
    else*/
        /* il doit y avoir au moins 1 joueur (humain ou ordi) */
        return (nbp+new_nbc > 0);
}

int grise_nbc()
{
    if ( (network) || (game_mode == GAME_CHALLENGE) )
    {
        if (ptr_menus[1][0][MENU_1_0_F_BOTS].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_F_BOTS].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][0][MENU_1_0_F_BOTS].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_F_BOTS].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_difficulte()
{
    if (nbc == 0)
    {
        if (ptr_menus[1][0][MENU_1_0_BOTS_LEVEL].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_BOTS_LEVEL].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][0][MENU_1_0_BOTS_LEVEL].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_BOTS_LEVEL].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_same_pieces()
{
    if ( (network) || (nbp+nbc <= 1) )
    {
        if (ptr_menus[1][0][MENU_1_0_SAME_PIECES].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_SAME_PIECES].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][0][MENU_1_0_SAME_PIECES].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_SAME_PIECES].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_hauteur_ini()
{
    if ( (network) || (en_pause) )
    {
        if (ptr_menus[1][0][MENU_1_0_HANDICAP].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_HANDICAP].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][0][MENU_1_0_HANDICAP].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_HANDICAP].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int verifie_stats(int new_stats)
{
    /*  */
    /*if (new_stats)
        return (!eccentric);
    else*/
        return 1;
}

int grise_stats()
{
    if (nbp+nbc > 3)
    {
        if (ptr_menus[1][0][MENU_1_0_STATS].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_STATS].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][0][MENU_1_0_STATS].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_STATS].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_time()
{
    if ( (network) || (game_mode == GAME_CHALLENGE) )
    {
        if (ptr_menus[1][0][MENU_1_0_TIME].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_TIME].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][0][MENU_1_0_TIME].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_TIME].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int verifie_eccentric(int new_eccentric)
{
    /*  */
    /*if (new_eccentric)
        return (!stats);
    else*/
        return 1;
}

int grise_eccentric()
{
    /*  */
    return 0;
}

int verifie_bonus_levels(int new_bonus_level)
{
    return (game_mode != GAME_CHALLENGE) && (nbc == 0) && (!get_game_team())
        && (get_time_limite() <= 1)
        /*  */
        && ( (new_bonus_level == NO_BONUS)
            || (new_bonus_level == BONUS_RANDOM)
            || (new_bonus_level == BONUS_BRIX) );
}

int grise_bonus_levels()
{
    if ( (network) || (game_mode == GAME_CHALLENGE) || (nbc > 0) || (nbp > 4)
        || (get_game_team()) || (get_time_limite() > 1) )
    {
        if (ptr_menus[1][0][MENU_1_0_BONUS_LEVELS].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_BONUS_LEVELS].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][0][MENU_1_0_BONUS_LEVELS].o_choix_actif)
        {
            ptr_menus[1][0][MENU_1_0_BONUS_LEVELS].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_window_msg()
{
    if (nbp+nbc > 4)
    {
        if (ptr_menus[1][1][MENU_1_1_WINDOW_MSG].o_choix_actif)
        {
            ptr_menus[1][1][MENU_1_1_WINDOW_MSG].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][1][MENU_1_1_WINDOW_MSG].o_choix_actif)
        {
            ptr_menus[1][1][MENU_1_1_WINDOW_MSG].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_aire()
{
    if (game_mode == GAME_CHALLENGE)
    {
        if (ptr_menus[1][1][MENU_1_1_GAME_AREA].o_choix_actif)
        {
            ptr_menus[1][1][MENU_1_1_GAME_AREA].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][1][MENU_1_1_GAME_AREA].o_choix_actif)
        {
            ptr_menus[1][1][MENU_1_1_GAME_AREA].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int verifie_team1(int new_team1)
{
    if ( (nbp+nbc == 1) && (new_team1 > 0) )
        return 0;
    else
        return (new_team1+team[1]+team[2] <= nbp+nbc);
}

int verifie_team2(int new_team2)
{
    if ( (nbp+nbc == 1) && (new_team2 > 0) )
        return 0;
    else
        return (team[0]+new_team2+team[2] <= nbp+nbc);
}

int verifie_team3(int new_team3)
{
    if ( (nbp+nbc == 1) && (new_team3 > 0) )
        return 0;
    else
        return (team[0]+team[1]+new_team3 <= nbp+nbc);
}

int grise_cheat()
{
    /*  trouver un truc amusant pour autoriser les cheats */
    /* seulement dans certains cas.....                              */
    if (ptr_menus[1][1][MENU_1_1_CHEAT].o_choix_actif)
    {
        ptr_menus[1][1][MENU_1_1_CHEAT].o_choix_actif = 0;
        return 1;
    }
    else
        return 0;
}

int grise_pieces_editor()
{
    if ( (network) && (!net_master) )
    {
        if (ptr_menus[1][1][MENU_1_1_PIECES_EDITOR].o_choix_actif)
        {
            ptr_menus[1][1][MENU_1_1_PIECES_EDITOR].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][1][MENU_1_1_PIECES_EDITOR].o_choix_actif)
        {
            ptr_menus[1][1][MENU_1_1_PIECES_EDITOR].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_redefine_keys()
{
    if ( (network) && (!net_master) )
    {
        if (ptr_menus[1][1][MENU_1_1_REDEFINE_KEYS].o_choix_actif)
        {
            ptr_menus[1][1][MENU_1_1_REDEFINE_KEYS].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[1][1][MENU_1_1_REDEFINE_KEYS].o_choix_actif)
        {
            ptr_menus[1][1][MENU_1_1_REDEFINE_KEYS].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_musique_menu()
{
    if ( (!sb16) || (no_sound) || (en_pause) )
    {
        if (ptr_menus[2][0][MENU_2_0_MUSIC_MENU].o_choix_actif)
        {
            ptr_menus[2][0][MENU_2_0_MUSIC_MENU].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[2][0][MENU_2_0_MUSIC_MENU].o_choix_actif)
        {
            ptr_menus[2][0][MENU_2_0_MUSIC_MENU].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_musique_jeu()
{
    if ( (!sb16) || (no_sound) )
    {
        if (ptr_menus[2][0][MENU_2_0_MUSIC_GAME].o_choix_actif)
        {
            ptr_menus[2][0][MENU_2_0_MUSIC_GAME].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[2][0][MENU_2_0_MUSIC_GAME].o_choix_actif)
        {
            ptr_menus[2][0][MENU_2_0_MUSIC_GAME].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_detect_sb16()
{
    if ( (sb16) || (no_sound) )
    {
        if (ptr_menus[2][1][MENU_2_1_DETECT_SB16].o_choix_actif)
        {
            ptr_menus[2][1][MENU_2_1_DETECT_SB16].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[2][1][MENU_2_1_DETECT_SB16].o_choix_actif)
        {
            ptr_menus[2][1][MENU_2_1_DETECT_SB16].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_port()
{
    #ifdef MSDOS
    return 0;
    #else
    if (ptr_menus[2][1][MENU_2_1_SB16_PORT].o_choix_actif)
    {
        ptr_menus[2][1][MENU_2_1_SB16_PORT].o_choix_actif = 0;
        return 1;
    }
    else
        return 0;
    #endif
}

int grise_irq()
{
    #ifdef MSDOS
    return 0;
    #else
    if (ptr_menus[2][1][MENU_2_1_SB16_IRQ].o_choix_actif)
    {
        ptr_menus[2][1][MENU_2_1_SB16_IRQ].o_choix_actif = 0;
        return 1;
    }
    else
        return 0;
    #endif
}

int grise_create_game()
{
    if (network)
    {
        if (ptr_menus[3][0][MENU_3_0_CREATE_GAME].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_CREATE_GAME].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][0][MENU_3_0_CREATE_GAME].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_CREATE_GAME].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_join_game()
{
    if (network)
    {
        if (ptr_menus[3][0][MENU_3_0_JOIN_GAME].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_JOIN_GAME].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][0][MENU_3_0_JOIN_GAME].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_JOIN_GAME].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_cancel_net()
{
    if (!network)
    {
        if (ptr_menus[3][0][MENU_3_0_CANCEL_NET].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_CANCEL_NET].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][0][MENU_3_0_CANCEL_NET].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_CANCEL_NET].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_net_name()
{
    if (network)
    {
        if (ptr_menus[3][0][MENU_3_0_NET_NAME].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_NET_NAME].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][0][MENU_3_0_NET_NAME].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_NET_NAME].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int verifie_type_reseau(int new_type_reseau)
{
    /*  faire en fonction de la detection du reseau !!!  */
    #ifdef MSDOS
    /*return (new_type_reseau == PROTO_IPX);*/
    return 0;
    #else
    return (new_type_reseau == PROTO_TCPIP);
    #endif
}

int grise_type_reseau()
{
    if (network)
    {
        if (ptr_menus[3][0][MENU_3_0_NET_TYPE].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_NET_TYPE].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][0][MENU_3_0_NET_TYPE].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_NET_TYPE].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_net_server()
{
    if ( (network) &&
        ( (net_master) || (net_adresse_serveur != 0) ) )
    {
        if (ptr_menus[3][0][MENU_3_0_NET_SERVER].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_NET_SERVER].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][0][MENU_3_0_NET_SERVER].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_NET_SERVER].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_net_nbj_max()
{
    if (network)
    {
        if (ptr_menus[3][0][MENU_3_0_NBJ_MAX].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_NBJ_MAX].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][0][MENU_3_0_NBJ_MAX].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_NBJ_MAX].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_net_allow_bots()
{
    if (network)
    {
        if (ptr_menus[3][0][MENU_3_0_ALLOW_BOTS].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_ALLOW_BOTS].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][0][MENU_3_0_ALLOW_BOTS].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_ALLOW_BOTS].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_net_bonus_levels()
{
    /*  */
    if ( 1 /*(network) && (!net_master)*/ )
    {
        if (ptr_menus[3][0][MENU_3_0_BONUS_LEVELS].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_BONUS_LEVELS].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][0][MENU_3_0_BONUS_LEVELS].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_BONUS_LEVELS].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_net_same_pieces()
{
    /*  */
    if ( 1 /*(network) && (!net_master)*/ )
    {
        if (ptr_menus[3][0][MENU_3_0_SAME_PIECES].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_SAME_PIECES].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][0][MENU_3_0_SAME_PIECES].o_choix_actif)
        {
            ptr_menus[3][0][MENU_3_0_SAME_PIECES].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_net_view_other()
{
    /*  */
    if ( 1 /*(network) && (!net_master)*/ )
    {
        if (ptr_menus[3][1][MENU_3_1_VIEW_OTHER].o_choix_actif)
        {
            ptr_menus[3][1][MENU_3_1_VIEW_OTHER].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][1][MENU_3_1_VIEW_OTHER].o_choix_actif)
        {
            ptr_menus[3][1][MENU_3_1_VIEW_OTHER].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_net_chat()
{
    /*  */
    if ( 1 /*(network) && (!net_master)*/ )
    {
        if (ptr_menus[3][1][MENU_3_1_CHAT].o_choix_actif)
        {
            ptr_menus[3][1][MENU_3_1_CHAT].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][1][MENU_3_1_CHAT].o_choix_actif)
        {
            ptr_menus[3][1][MENU_3_1_CHAT].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}

int grise_net_teams()
{
    /*  */
    if ( 1 /*(network) && (!net_master)*/ )
    {
        if (ptr_menus[3][1][MENU_3_1_TEAMS].o_choix_actif)
        {
            ptr_menus[3][1][MENU_3_1_TEAMS].o_choix_actif = 0;
            return 1;
        }
        else
            return 0;
    }
    else
    {
        if (!ptr_menus[3][1][MENU_3_1_TEAMS].o_choix_actif)
        {
            ptr_menus[3][1][MENU_3_1_TEAMS].o_choix_actif = 1;
            return 1;
        }
        else
            return 0;
    }
}
