/* ==== This file is part of Hell Module Player (HMP).
   ====
   ==== HMP is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== HMP is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with HMP; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/02/19

2001/09/06: FlashCode:
    - ajout de la licence
*/

#define __ASSEMBLY__

#include <linux/linkage.h>
#include <asm/errno.h>
#include <asm/unistd.h>

    .text
ENTRY(mon_clone)
    /* Verification des arguments */
    movl  $-EINVAL, %eax
    movl  4(%esp), %ecx     /* Le pointeur de fonction doit etre non nul */
    testl %ecx, %ecx
    jz    syscall_error
    movl  8(%esp), %ecx     /* L'adresse de la pile doit etre non nulle */
    testl %ecx, %ecx
    jz    syscall_error
    movl  16(%esp), %edx    /* Le nombre d'arguments doit etre positif */
    testl %edx, %edx
    js    syscall_error

    /* Allocation d'espace sur la pile et copie des arguments */
    movl  %edx, %eax
    negl  %eax
    lea   -4(%ecx, %eax, 4), %ecx
    jz    2f
1:  movl  16(%esp, %edx, 4), %eax
    movl  %eax, 0(%ecx, %edx, 4)
    dec   %edx
    jnz   1b
2:
    /* Sauvegarde du pointeur sur fonction
       Il sera depile apres l'appel de clone */
    movl  4(%esp), %eax
    movl  %eax, 0(%ecx)

    /* Appel de la primitive clone */
    pushl %ebx
    movl  16(%esp), %ebx
    movl  $__NR_clone, %eax
    int   $0x80
    popl  %ebx

    /* Test du code retour */
    test  %eax, %eax
    jl    syscall_error
    jz    thread_start
    ret

syscall_error:
    /* Erreur, on retourne -1 */
    movl  $-1, %eax
    ret

thread_start:
    /* Code du processus clone */
    subl  %ebp, %ebp
    call  *%ebx                 /* Appel de la fonction */
    movl  $__NR_exit, %eax      /* Terminaison du processus */
    int   $0x80
