/* ==========================================================================

            HMP32  Dos    (c) 07-02-1998 by FlashCode (Sebastien Helleu)
            HMP    Linux  (c) 19-02-1999 by FlashCode (Sebastien Helleu)

=============================================================================

   ==== This file is part of Hell Module Player (HMP).
   ====
   ==== HMP is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== HMP is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with HMP; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/02/19

2001/09/06: FlashCode:
    - ajout de la licence
*/

#define USE_SEQ_MACROS 1

#include <stdio.h>
#include <malloc.h>
#include <string.h>

#ifdef MSDOS
    #include <dos.h>
    #include <dpmi.h>
    #include <go32.h>
#endif

#ifdef CYGWIN
    #include <unistd.h>
    #include <fcntl.h>
    #include <pthread.h>
    #include <sys/soundcard.h>
    #include <sys/ioctl.h>
#endif

#ifdef LINUX
    #include <unistd.h>
    #include <signal.h>
    #include <fcntl.h>
    #include <linux/soundcard.h>
    #include <sys/ioctl.h>
    #include <sys/time.h>
//    #include <linux/sched.h>
#endif

#include "mod.h"

#ifdef LINUX
    #define CLONE_VM    0x00000100
    #define CLONE_FS    0x00000200
    #define CLONE_FILES 0x00000400
#endif

#ifdef MSDOS
__dpmi_paddr        old_int_irq;
_go32_dpmi_seginfo  wrap_int_irq;

int                 doublebuf_selector;
#endif

int             sb16_mixer;         // 1 si mixer OK, 0 si mixer non trouve

#if defined(CYGWIN) || defined(LINUX)
int             dsp;
int             mixer;
pid_t           pid_interrupt;
unsigned char   *ptr_dmabuffer;
#endif

#ifdef CYGWIN
pthread_t       sub_pid;
#endif

int             vol_ini, volume;
int             fin_mod;

modheader       header;
hmdheader       hheader;
unsigned char   nb_samples;
unsigned char   nb_patterns;
unsigned short  size_all_pat;

unsigned char   *pattern_comp;      // un pattern compresse
unsigned char   *sample_comp;       // un sample compresse
unsigned char   bit_en_cours;
unsigned short  taille_sample_decomp;
unsigned short  taille_pat_comp;
unsigned char   sample_compresse;

int             playing_module;     // 1 si un module est joue, 0 sinon

unsigned char   music_stop_at_end;  // 1 si la musique s'arrete a la fin
                                    // (pas de boucle)
unsigned char   module_fini;        // le module est fini (on ne joue plus)

#ifdef LINUX
#define STACKSIZE 4096
unsigned char   *stack;
unsigned char   *ptr_stack;

extern int mon_clone(int (*)(), void *, int, int, ...);
#endif

extern void startplaying();

// ====================== Dtection SB16 ====================================

#define CLI __asm__ __volatile__ ("cli");
#define STI __asm__ __volatile__ ("sti");


#ifdef MSDOS

#define IRET __asm__ __volatile__ ("iret");

#define PUSHA __asm__ __volatile__ ("pusha");
#define POPA __asm__ __volatile__ ("popa");

void detect_port()
{
    signed char     octet;
    unsigned char   i;

    port_sb = 0x210;
    do
    {
        outportb(port_sb+6, 1);
        octet=inportb(port_sb+6);
        octet=inportb(port_sb+6);
        octet=inportb(port_sb+6);
        octet=inportb(port_sb+6);
        outportb(port_sb+6, 0);
        i = 100;
        do
        {
            octet = inportb(port_sb+0x0E);
            if (octet < 0)
                if (inportb(port_sb+0x0A) == 0xAA)
                    return;
            i--;
        } while (i != 0);

        port_sb += 0x10;
    } while (port_sb <= 0x260);
    port_sb = 0;
}

void test_int2()
{
    //CLI
    //PUSHA
    irq_sb = 2;
    inportb(port_sb+0x0E);
    outportb(0x20, 0x20);
    //POPA
    //STI
    //IRET
}

void test_int3()
{
    //CLI
    //PUSHA
    irq_sb = 3;
    inportb(port_sb+0x0E);
    outportb(0x20, 0x20);
    //POPA
    //STI
    //IRET
}

void test_int5()
{
    //CLI
    //PUSHA
    irq_sb = 5;
    inportb(port_sb+0x0E);
    outportb(0x20, 0x20);
    //POPA
    //STI
    //IRET
}

void test_int7()
{
    //CLI
    //PUSHA
    irq_sb = 7;
    inportb(port_sb+0x0E);
    outportb(0x20, 0x20);
    //POPA
    //STI
    //IRET
}

/*void detect_irq()
{
    __dpmi_paddr        oldint2, oldint3, oldint5, oldint7;
    __dpmi_paddr        newint2, newint3, newint5, newint7;
    _go32_dpmi_seginfo  wrap2, wrap3, wrap5, wrap7;
    __dpmi_paddr    newint;

    char            port21;
    unsigned short  i;

    CLI
    port21 = inp(0x21);
    outp(0x21, 0xFF);

    //oldint2 = _dos_getvect(8+2);
    //oldint3 = _dos_getvect(8+3);
    //oldint5 = _dos_getvect(8+5);
    //oldint7 = _dos_getvect(8+7);
    __dpmi_get_protected_mode_interrupt_vector(8+2, &oldint2);
    __dpmi_get_protected_mode_interrupt_vector(8+3, &oldint3);
    __dpmi_get_protected_mode_interrupt_vector(8+5, &oldint5);
    __dpmi_get_protected_mode_interrupt_vector(8+7, &oldint7);

    //_dos_setvect(8+2, new_int2);
    //_dos_setvect(8+3, new_int3);
    //_dos_setvect(8+5, new_int5);
    //_dos_setvect(8+7, new_int7);
    newint.selector = _my_cs;
    newint.offset32 = (unsigned long)new_int2;
    __dpmi_set_protected_mode_interrupt_vector(8+2, &newint);
    newint.offset32 = (unsigned long)new_int3;
    __dpmi_set_protected_mode_interrupt_vector(8+3, &newint);
    newint.offset32 = (unsigned long)new_int5;
    __dpmi_set_protected_mode_interrupt_vector(8+5, &newint);
    newint.offset32 = (unsigned long)new_int7;
    __dpmi_set_protected_mode_interrupt_vector(8+7, &newint);


    outp(0x21, port21 & 83);
    STI
    irq_sb = 0;

    while ((signed char)inp(port_sb+0x0C) < 0) ;
    outp(port_sb+0x0C, 0xF2);

    i = 65535;
    while ( (i>0) && (irq_sb == 0) ) i--;
    outp(0x21, port21);

    CLI
    _dos_setvect(8+2, oldint2);
    _dos_setvect(8+3, oldint3);
    _dos_setvect(8+5, oldint5);
    _dos_setvect(8+7, oldint7);
    STI
}*/

void detect_irq()
{
    __dpmi_paddr        oldint2, oldint3, oldint5, oldint7;
    __dpmi_paddr        newint2, newint3, newint5, newint7;
    _go32_dpmi_seginfo  wrap2, wrap3, wrap5, wrap7;
    unsigned char       pic1default, pic2default;
    unsigned short      i;

    __dpmi_get_protected_mode_interrupt_vector(8+2, &oldint2);
    __dpmi_get_protected_mode_interrupt_vector(8+3, &oldint3);
    __dpmi_get_protected_mode_interrupt_vector(8+5, &oldint5);
    __dpmi_get_protected_mode_interrupt_vector(8+7, &oldint7);

    wrap2.pm_offset=(int)test_int2;
    wrap2.pm_selector=_my_cs();
    wrap3.pm_offset=(int)test_int3;
    wrap3.pm_selector=_my_cs();
    wrap5.pm_offset=(int)test_int5;
    wrap5.pm_selector=_my_cs();
    wrap7.pm_offset=(int)test_int7;
    wrap7.pm_selector=_my_cs();

    _go32_dpmi_allocate_iret_wrapper(&wrap2);
    _go32_dpmi_allocate_iret_wrapper(&wrap3);
    _go32_dpmi_allocate_iret_wrapper(&wrap5);
    _go32_dpmi_allocate_iret_wrapper(&wrap7);

    newint2.offset32=wrap2.pm_offset;
    newint2.selector=wrap2.pm_selector;
    newint3.offset32=wrap3.pm_offset;
    newint3.selector=wrap3.pm_selector;
    newint5.offset32=wrap5.pm_offset;
    newint5.selector=wrap5.pm_selector;
    newint7.offset32=wrap7.pm_offset;
    newint7.selector=wrap7.pm_selector;

    pic1default = inportb(0x21);
    pic2default = inportb(0xA1);

    outportb(0x21, pic1default & 0x53);
    outportb(0xA1, pic2default & 0xFB);
    __dpmi_set_protected_mode_interrupt_vector(8+2, &newint2);
    __dpmi_set_protected_mode_interrupt_vector(8+3, &newint3);
    __dpmi_set_protected_mode_interrupt_vector(8+5, &newint5);
    __dpmi_set_protected_mode_interrupt_vector(8+7, &newint7);

    irq_sb = 0;

    while ((signed char)inportb(port_sb+0x0C) < 0) ;
    outportb(port_sb+0x0C, 0xF2);

    i = 65535;
    while ( (i>0) && (irq_sb == 0) ) i--;

    outportb(0x21, pic1default);
    outportb(0xA1, pic2default);

    __dpmi_set_protected_mode_interrupt_vector(8+2, &oldint2);
    __dpmi_set_protected_mode_interrupt_vector(8+3, &oldint3);
    __dpmi_set_protected_mode_interrupt_vector(8+5, &oldint5);
    __dpmi_set_protected_mode_interrupt_vector(8+7, &oldint7);

    _go32_dpmi_free_iret_wrapper(&wrap2);
    _go32_dpmi_free_iret_wrapper(&wrap3);
    _go32_dpmi_free_iret_wrapper(&wrap5);
    _go32_dpmi_free_iret_wrapper(&wrap7);
}

int detect_sb16()
{
    detect_port();
    if (port_sb == 0)
        return -1;  // port pas trouv
    else
    {
        detect_irq();
        if (irq_sb == 0)
            return -2;  // irq pas trouv
        else
            return 0;   // ok !
    }
}

void (*old_irq)();

void new_irq()
{
    unsigned char   octet;

    //PUSHA
    octet = inportb(port_sb+0x0E);
    while (inportb(port_sb+0x0C) > 127) ;
    outportb(port_sb+0x0C, 0x14);
    while (inportb(port_sb+0x0C) > 127) ;
    outportb(port_sb+0x0C, 0xFF);
    while (inportb(port_sb+0x0C) > 127) ;
    outportb(port_sb+0x0C, 0xFF);
    outportb(0x20, 0x20);
    //POPA
}

#endif

#ifdef CYGWIN
int detect_sb16()
{
    //  a changer !!!!!!!!!!!!
    port_sb = 0x220;
    irq_sb = 5;
    return 0;
}
#endif

#ifdef MSDOS
void mod_detourne_interruption(int no_int, int adr_new_int,
                               __dpmi_paddr *old_int, _go32_dpmi_seginfo *wrap_int)
{
    __dpmi_paddr    new_int;

    // sauve l'ancienne interruption
    __dpmi_get_protected_mode_interrupt_vector(no_int, old_int);
    // alloue le "wrapper" pour la nouvelle interruption
    wrap_int->pm_offset = adr_new_int;
    wrap_int->pm_selector = _my_cs();
    _go32_dpmi_allocate_iret_wrapper(wrap_int);
    // et enfin installe la nouvelle interruption
    new_int.offset32 = wrap_int->pm_offset;
    new_int.selector = wrap_int->pm_selector;
    __dpmi_set_protected_mode_interrupt_vector(no_int, &new_int);
}
#endif

#ifdef MSDOS
void mod_restaure_interruption(int no_int, __dpmi_paddr *old_int,
                               _go32_dpmi_seginfo *wrap_int)
{
    // reinstalle l'ancienne interruption
    __dpmi_set_protected_mode_interrupt_vector(no_int, old_int);
    // desalloue le "wrapper" associe
    _go32_dpmi_free_iret_wrapper(wrap_int);
}
#endif

#ifdef LINUX
int clone_playmodule()
{
    audio_buf_info  info;

    info.fragments = 0;
    info.fragstotal = 0;
    while (fin_mod == 0)
    {
        if ( (playing_module) && (!module_fini))
        {
            ptr_dmabuffer = &(dmabuffer[dmaflag*512]);
            __asm__ __volatile__ ("
                movl ptr_dmabuffer,%%edi\n
                movl $512,%%ebx\n
                call getsamples"
                :
                :
                : "ebx", "edi");
            dmaflag = dmaflag^1;

            write(dsp, ptr_dmabuffer, 512);

            if (!ioctl(dsp, SNDCTL_DSP_GETOSPACE, &info))
            {
                while (info.fragments < info.fragstotal-2)
                {
                    //printf("fragsize = %d\n", info.fragsize);
                    usleep(1000000*info.fragsize/mixspeed);
                    ioctl(dsp, SNDCTL_DSP_GETOSPACE, &info);
                }
            }
        }
    }
    return 0;
}
#endif

#ifdef CYGWIN
void *thread_playmodule()
{
    audio_buf_info  info;

    info.fragments = 0;
    info.fragstotal = 0;
    while (fin_mod == 0)
    {
        if ( (playing_module) && (!module_fini))
        {
            ptr_dmabuffer = &(dmabuffer[dmaflag*512]);
            __asm__ __volatile__ ("
                movl _ptr_dmabuffer,%%edi\n
                movl $512,%%ebx\n
                call _getsamples"
                :
                :
                : "ebx", "edi");
            dmaflag = dmaflag^1;

            write(dsp, ptr_dmabuffer, 512);

            #ifdef LINUX
            if (!ioctl(dsp, SNDCTL_DSP_GETOSPACE, &info))
            {
                while (info.fragments < info.fragstotal-2)
                {
                    //printf("fragsize = %d\n", info.fragsize);
                    usleep(1000000*info.fragsize/mixspeed);
                    ioctl(dsp, SNDCTL_DSP_GETOSPACE, &info);
                }
            }
            #endif
        }
    }
    pthread_exit(NULL);
    return NULL;
}
#endif

// dos_reset_sb: reinitialise la carte SoundBlaster sous Dos

#ifdef MSDOS
void dos_reset_sb()
{
    unsigned char   octet, i;

    outportb(port_sb+0x06, 1);
    octet = inportb(port_sb+0x06);
    octet = inportb(port_sb+0x06);
    octet = inportb(port_sb+0x06);
    octet = inportb(port_sb+0x06);
    outportb(port_sb+0x06, 0);
    i = 100;
    do
    {
        octet = inportb(port_sb+0x0E);
        if (octet > 127)
            if (inportb(port_sb+0x0A) == 0xAA)
                break;
        i--;
    } while (i != 0);
    if (i != 0)
    {
        while (inportb(port_sb+0x0C) > 127) ;
        outportb(port_sb+0x0C, 0xD1);
        while (inportb(port_sb+0x0C) > 127) ;
        outportb(port_sb+0x0C, 0x40);
        while (inportb(port_sb+0x0C) > 127) ;
        outportb(port_sb+0x0C, -((1000000/mixspeed) & 0xFF));
        while (inportb(port_sb+0x0C) > 127) ;
        outportb(port_sb+0x0C, 0x14);
        while (inportb(port_sb+0x0C) > 127) ;
        outportb(port_sb+0x0C, 0xFF);
        while (inportb(port_sb+0x0C) > 127) ;
        outportb(port_sb+0x0C, 0xFF);
    }
    else
        printf("sbinit: timeout !\n");
}
#endif

// sbinit: initialise la SoundBlaster
//         Renvoie:  0 = OK
//                  -1 = pas assez de memoire pour le double buffer
//                  -2 = probleme initialisation carte SoundBlaster

int sbinit()
{
    #ifdef MSDOS
        unsigned char   octet;
        int             adr;
    #else
        int     valeur;
    #endif

    #ifdef MSDOS
    // allocation d'un buffer en memoire basse (obligatoire pour le DMA)
    if ((adr = __dpmi_allocate_dos_memory(256, &doublebuf_selector)) == -1)
        return -1;
    doublebuffer = (unsigned char *)(adr << 4);
    if (doublebuffer == NULL)
        return -1;
    g_select = _dos_ds;
    __asm__ __volatile__ ("
        push %%es\n
        movw _g_select, %%es\n
        movl _doublebuffer, %%edi\n
        movl $2048, %%ecx\n
        xorb %%al, %%al\n
        movb $123, %%al\n
        rep\n
        stosb\n
        pop  %%es"
        :
        :
        : "al", "edi", "ecx"
        );
    #else
    doublebuffer = (unsigned char *)malloc(2048);
    if (doublebuffer == NULL)
        return -1;
    memset(doublebuffer, 0x80, 2048);
    #endif
    startplaying();
    dmaflag = 0;
    dmabuffer = doublebuffer;
    #ifdef MSDOS
        CLI
        octet = inportb(0x21);
        outportb(0x21, 0xFF);

        outportb(0x0A, 0x05);   // masque le DMA 1
        outportb(0x0C, 0x00);   // supprime le "flip-flop"

        // fixe l'adresse du buffer pour le DMA 1
        outportb(0x02, (unsigned int)dmabuffer & 0xFF);
        outportb(0x02, ((unsigned int)dmabuffer >> 8) & 0xFF);
        outportb(0x83, ((unsigned int)dmabuffer >> 16) & 0xFF);

        // fixe la taille du transfert pour le DMA 1
        outportb(0x03, (2048-1) & 0xFF);
        outportb(0x03, ((2048-1) >> 8) & 0xFF);

        outportb(0x0B, 0x59);   // active le mode unique(0x40)+lect_transfer(0x08)+autoinit_enable(0x10)+dma1(0x01)
        outportb(0x0A, 0x01);   // libere le DMA 1

        mod_detourne_interruption(8+irq_sb, (int)new_irq, &old_int_irq, &wrap_int_irq);

        /*old_irq = _dos_getvect(8+irq_sb);
        _dos_setvect(8+irq_sb, new_irq);*/

        dos_reset_sb();

        outportb(0x21, octet & ((1 << irq_sb) ^ 0xFF));

        STI
        vol_ini = getvolume();
        volume = vol_ini;
        playing_module = 0;
    #else
        dsp = open("/dev/dsp", O_WRONLY | O_NONBLOCK);
        if (dsp < 0)
            return -2;

        /*valeur = 1;
        ioctl(dsp, SNDCTL_DSP_RESET, &valeur);*/

        #ifdef LINUX
        valeur = 0;
        ioctl(dsp, SNDCTL_DSP_SAMPLESIZE, &valeur);

        //valeur = 0x00020007;
        valeur = 0x20009;
        if (ioctl(dsp, SNDCTL_DSP_SETFRAGMENT, &valeur))
            fprintf(stderr, "sbinit: error set_fragment\n");

        valeur = 1;
        ioctl(dsp, SNDCTL_DSP_RESET, &valeur);
        #endif

        valeur = mixspeed;
        ioctl(dsp, SNDCTL_DSP_SPEED, &valeur);
        valeur = 0;
        ioctl(dsp, SNDCTL_DSP_STEREO, &valeur);
        valeur = 1;
        ioctl(dsp, SNDCTL_DSP_SYNC, &valeur);

        valeur = 0;
        ioctl(dsp, SNDCTL_DSP_GETBLKSIZE, &valeur);
        //printf("sbinit: dsp_getblksize = %d\n", valeur);

        valeur = 8;
        ioctl(dsp, SNDCTL_DSP_SAMPLESIZE, &valeur);

        mixer = open("/dev/mixer", O_RDWR);
        sb16_mixer = (mixer >= 0);

        vol_ini = getvolume();
        volume = vol_ini;

        playing_module = 0;
        fin_mod = 0;

        #ifdef CYGWIN
        pthread_create(&sub_pid, NULL, (void *)thread_playmodule, NULL);
        #endif

        #ifdef LINUX
        stack = (unsigned char *)malloc(STACKSIZE);
        ptr_stack = (void *)(STACKSIZE+(unsigned char *)stack);
        pid_interrupt = mon_clone(clone_playmodule, (void *)ptr_stack,
            CLONE_VM | CLONE_FS | CLONE_FILES, 0, NULL);
        #endif
    #endif
    return 0;
}

void sbdone()
{
    #ifdef MSDOS
        unsigned char   octet;

        CLI
        octet = inportb(0x21);
        outportb(0x21, 0xFF);

        mod_restaure_interruption(8+irq_sb, &old_int_irq, &wrap_int_irq);

        //_dos_setvect(8+irq_sb, old_irq);

        while ((signed char)inportb(port_sb+0x0C) < 0) ;
        outportb(port_sb+0x0C, 0xD0);
        while ((signed char)inportb(port_sb+0x0C) < 0) ;
        outportb(port_sb+0x0C, 0xD3);
        outportb(0x21, octet & ((1 << irq_sb) ^ 255));
        STI
    #else
        int     valeur;

        fin_mod = 1;    // force le clone a se terminer
        #ifdef LINUX
        kill(pid_interrupt, SIGKILL);
        #endif
        valeur = 1;
        ioctl(dsp, SNDCTL_DSP_RESET, &valeur);
        close(dsp);
        close(mixer);
    #endif
    free(doublebuffer);
}

/*#ifndef MSDOS
void sb_fin_interrupt()
{
    fin_mod = 1;
}
#endif*/

void playmodule()
{
    playing_module = 1;

    startplaying();
    #ifdef LINUX
    kill(pid_interrupt, SIGCONT);
    #endif

    /*pid_interrupt = fork();
    if (pid_interrupt == (pid_t)0)
    {
        // = sbpoll en tache de fond (Linux seulement) !
        signal(SIGUSR1, sb_fin_interrupt);
        while (fin_mod == 0)
        {
            dmaflag = dmaflag^1;
            ptr_dmabuffer = &(dmabuffer[dmaflag*1024]);
            __asm__ __volatile__ ("
                movl ptr_dmabuffer,%edi\n
                movl $1024,%ebx\n
                call getsamples");
            write(dsp, ptr_dmabuffer, 1024);
        }
        _exit(0);
    }*/
    /*mon_clone(clone_playmodule, (void *)ptr_stack,
        CLONE_VM | CLONE_FS | CLONE_FILES, 0, NULL);*/
}

void stopmodule()
{
    //int     valeur;

    // envoie le signal USR1 indiquant au fils d'arreter de jouer le module
    //kill(pid_interrupt, SIGUSR1);
    //kill(pid_interrupt, SIGKILL);
    //while (playing_module) ;
    /*valeur = 1;
    ioctl(dsp, SNDCTL_DSP_RESET, &valeur);*/
    playing_module = 0;

    memset(doublebuffer, 0x80, 2048);
    #ifdef LINUX
    kill(pid_interrupt, SIGSTOP);
    #endif

    /*valeur = 1;
    ioctl(dsp, SNDCTL_DSP_RESET, &valeur);
        valeur = 0;
        ioctl(dsp, SNDCTL_DSP_STEREO, &valeur);
        valeur = 8;
        ioctl(dsp, SNDCTL_DSP_SAMPLESIZE, &valeur);
        valeur = mixspeed;
        ioctl(dsp, SNDCTL_DSP_SPEED, &valeur);*/



    /*close(dsp);
    dsp = open("/dev/dsp", O_WRONLY);
    valeur = 1;
    ioctl(dsp, SNDCTL_DSP_RESET, &valeur);
    valeur = 0;
    ioctl(dsp, SNDCTL_DSP_STEREO, &valeur);
    valeur = 8;
    ioctl(dsp, SNDCTL_DSP_SAMPLESIZE, &valeur);
    valeur = mixspeed;
    ioctl(dsp, SNDCTL_DSP_SPEED, &valeur);
    memset(dmabuffer, 0x80, 2048);*/

    //startplaying();
}

// playsample: joue un sample sur une piste avec un certain pitch

void playsample(int track_fx, int no_sample, unsigned short pitch, unsigned char vol)
{
    __asm__ __volatile__ (
        #if defined(MSDOS) || defined(CYGWIN)
        "movl $_tracks, %%edi\n"
        #else
        "movl $tracks, %%edi\n"
        #endif
        "addl %0, %%edi\n

        movl %1, %%ebx\n
        shll $2, %%ebx\n"
        #if defined(MSDOS) || defined(CYGWIN)
        "movl _sampptr(%%ebx), %%eax\n"
        #else
        "movl sampptr(%%ebx), %%eax\n"
        #endif
        "movl %%eax, 0(%%edi)\n
        xorw %%ax, %%ax\n
        movw %%ax, 4(%%edi)\n
        movl %1, %%ebx\n
        shll $1, %%ebx\n"
        #if defined(MSDOS) || defined(CYGWIN)
        "movw _samplen(%%ebx), %%ax\n"
        #else
        "movw samplen(%%ebx), %%ax\n"
        #endif
        "movw %%ax, 6(%%edi)\n

        xorw %%ax, %%ax\n
        movw %%ax, 8(%%edi)\n
        movw %%ax, 10(%%edi)\n
        movb %3, %%al\n
        movb %%al, 12(%%edi)\n
        xorb %%al, %%al\n
        movb %%al, 13(%%edi)\n
        movw $10, %%ax\n
        movw %%ax, 14(%%edi)\n
        movw %2, %%ax\n
        movw %%ax, 16(%%edi)\n
        xorw %%ax, %%ax\n
        movw %%ax, 18(%%edi)\n
        movw %%ax, 20(%%edi)\n
        movb %%al, 22(%%edi)\n
        movb $10, %%al\n
        movb %%al, 23(%%edi)\n
        xorb %%al, %%al\n
        movb %%al, 24(%%edi)\n
        movb %%al, 25(%%edi)\n
        movw %%ax, 26(%%edi)\n
        movw %%ax, 28(%%edi)\n
        movw %%ax, 30(%%edi)\n
        movw %%ax, 32(%%edi)"
        :
        : "g" (track_fx*34), "g" (no_sample), "g" (pitch), "g" (vol)
        : "eax", "ebx", "edi" );
}

// ====================== Chargement module =================================

void clearmodinfo()
{
    unsigned char   i;

    orderlen = 0;
    restart = 0;
    for (i = 0; i < 128; i++) order[i] = 0;
    for (i = 0; i < 31; i++)
    {
        samplen[i] = 0; samprep[i] = 0;
        sampreplen[i] = 0; sampvol[i] = 0;
    }
}

int swap(unsigned short nombre)
{
    return (nombre >> 8)+(nombre << 8);
//    __asm__ __volatile__ ("
//        xchg %%ah, %%al" );
}

// loadmodule: charge un module au format .MOD (Amiga)

int loadmodule(unsigned char *nom_module, long pos_fin)
{
    //    0 : OK
    //   -1 : fichier non trouv
    //   -2 : pas assez de mmoire
    // < -2 : le fichier n'est pas au format MOD:
    //      -3 = impossible de lire le "header"
    //      -4 = impossible de lire les patterns
    //      -5 = impossible de lire les samples

    FILE            *fichier;
    unsigned int    i, j;

    fichier = fopen(nom_module, "rb");
    if (fichier == NULL)
        return(-1); // fichier non trouv
    if (pos_fin != 0)
        fseek(fichier, -pos_fin, SEEK_END);
    clearmodinfo();
    if (fread(&header, sizeof(modheader), 1, fichier) != 1)
    {
        fclose(fichier);
        return(-3);      // le fichier n'est pas un MOD
    }
    if (header.mhsign == 0x4E484336)
    {
        numtracks = 6;
        size_pattern = 1536;
    }
    else
        if (header.mhsign == 0x4E484338)
        {
            numtracks = 8;
            size_pattern = 2048;
        }
        else
            if ( (header.mhsign != 0x2E4B2E4D) &&
                (header.mhsign != 0x34544C46) )
            {
                numtracks = 4;
                size_pattern = 1024;
                memcpy(&header.mhorderlen,
                    &header.mhsamples[15],130);
                memset(&header.mhsamples[15],0,
                    16*sizeof(modsample));
                if (fseek(fichier,600,SEEK_SET) != 0)
                {
                    fclose(fichier);
                    return(-3);  // le fichier n'est pas un MOD
                }
            }
            else
            {
                numtracks = 4;
                size_pattern = 1024;
            }
    orderlen = header.mhorderlen;
    if (header.mhrestart >= orderlen)
        restart=0;
    else
        restart = header.mhrestart;
    j = 0;
    for (i = 0; i < 128; i++)
    {
        order[i] = header.mhorder[i];
        if (order[i] >= j) j = order[i];
    }
    nb_patterns = j+1;
    size_all_pat = nb_patterns*size_pattern;
    if ((patterns = (unsigned char *)malloc(size_all_pat)) == NULL)
    {
        fclose(fichier);
        return(-2);  // pas assez de mmoire
    }
    if (fread(patterns, size_all_pat, 1, fichier) != 1)
    {
        free(patterns);
        fclose(fichier);
        return(-4);  // pas un MOD
    }
    for (i = 0; i < 31; i++)
    {
        samplen[i] = swap(header.mhsamples[i].mslength)<<1;
        sampvol[i] = header.mhsamples[i].msvolume;
        samprep[i] = swap(header.mhsamples[i].msrepeat)<<1;
        sampreplen[i] = swap(header.mhsamples[i].msreplen)<<1;
    }
    nb_samples = 0;
    for (i = 0; i < 31; i++)
        if (samplen[i] > 0)
        {
            if ((sampptr[i] = (unsigned char *)malloc(samplen[i])) == NULL)
            {
                free(patterns);
                for (j = 0; j < i; j++) free(sampptr[j]);
                fclose(fichier);
                return(-2); // pas assez de mmoire
            }
            nb_samples++;
            if (fread(sampptr[i], samplen[i], 1, fichier) != 1)
            {
                fclose(fichier);
                return 0;
                free(patterns);
                for (j = 0; j < i; j++)
                    if (sampptr[j] != NULL)
                        free(sampptr[j]);
                fclose(fichier);
                return(-5); // pas au format MOD
            }
        }
    fclose(fichier);
    return(0);
}

// decompresse_patterns: decompresse les patterns compresses d'un .HMD

void decompresse_patterns()
{
    int     i, j, k, m;

    i = 0;
    j = 0;
    do
    {
        switch (pattern_comp[i] & 3)
        {
            case 0:
                memset(&patterns[j], 0, 4*((pattern_comp[i] >> 2)+1));
                j += 4*((pattern_comp[i] >> 2)+1);
                i++;
                break;
            case 1:
                for (k = 0; k < (pattern_comp[i] >> 2)+1; k++)
                {
                    memmove(&patterns[j], &patterns[j-4], 4);
                    j += 4;
                }
                i++;
                break;
            case 2:
                memmove(&patterns[j], &patterns[j-4*(pattern_comp[i] >> 2)], 4);
                j += 4;
                i++;
                break;
            case 3:
                m = i+1;
                for (k = 0; k < 4; k++)
                {
                    if ( (pattern_comp[i] & (128 >> k)) != 0)
                    {
                        patterns[j] = pattern_comp[m];
                        m++;
                    }
                    else
                        patterns[j] = 0;
                    j++;
                }
                i = m;

                break;
        }
    } while (j < size_all_pat);
}

unsigned char read_bit(int *position)
{
    unsigned char   res;

    res = (sample_comp[*position] >> bit_en_cours) & 1;
    bit_en_cours++;
    if (bit_en_cours == 8)
    {
        (*position)++;
        bit_en_cours = 0;
    }
    return res;
}

void decompresse_sample(int nosample)
{
    int             i, j, k;
    unsigned char   signe, octet, octet2;

    sampptr[nosample][0] = sample_comp[0];
    i = 1;
    bit_en_cours = 0;
    for (j = 1; j < taille_sample_decomp; j++)
    {
        signe = read_bit(&i);
        if (read_bit(&i) == 1)
        {
            octet = 0;
            for (k = 0; k < 3; k++)
                octet |= (read_bit(&i) << k);
        }
        else
        {
            octet = 8;
            while (read_bit(&i) == 0)
                octet += 16;
            octet2 = 0;
            for (k = 0; k < 4; k++)
                octet2 |= (read_bit(&i) << k);
            octet += octet2;
        }
        if (signe == 1)
            octet ^= 255;
        sampptr[nosample][j] = sampptr[nosample][j-1]+octet;
    }
}

// load_hmodule: charge un module au format .HMD (HellModule)

int load_hmodule(unsigned char *nom_module, long pos_fin)
{
    //    0 : OK
    //   -1 : fichier non trouv
    //   -2 : pas assez de mmoire
    // < -2 : le fichier n'est pas au format HMD:
    //      -3 = impossible de lire le "header"
    //      -4 = impossible de lire les patterns
    //      -5 = impossible de lire les samples

    FILE            *fichier;
    unsigned int    i, j;

    fichier = fopen(nom_module, "rb");
    if (fichier == NULL)
        return(-1); // fichier non trouv
    if (pos_fin != 0)
        fseek(fichier, -pos_fin, SEEK_END);
    clearmodinfo();
    if (fread(&hheader, sizeof(hmdheader), 1, fichier) != 1)
    {
        fclose(fichier);
        return(-3);      // le fichier n'est pas un MOD
    }

    numtracks = hheader.shnbtracks;
    switch (numtracks)
    {
        case 4 :size_pattern = 1024; break;
        case 6 :size_pattern = 1536; break;
        case 8 :size_pattern = 2048; break;
        default:fclose(fichier); return -3;
    }

    orderlen = hheader.shorderlen;
    if (hheader.shrestart >= orderlen)
        restart=0;
    else
        restart = hheader.shrestart;

    j = 0;
    for (i = 0; i < 128; i++)
    {
        order[i] = hheader.shorder[i];
        if (order[i] >= j) j = order[i];
    }
    size_all_pat = (j+1)*size_pattern;

    for (i = 0; i < 31; i++)
    {
        samplen[i] = hheader.shsamples[i].mslength;
        sampvol[i] = hheader.shsamples[i].msvolume;
        samprep[i] = swap(hheader.shsamples[i].msrepeat)<<1;
        sampreplen[i] = swap(hheader.shsamples[i].msreplen)<<1;
    }
    nb_samples = 0;
    for (i = 0; i < 31; i++)
        if (samplen[i] > 0)
        {
            nb_samples++;
            fread(&sample_compresse, 1, 1, fichier);
            if (sample_compresse)
            {
                samplen[i] -= 2;
                if ((sample_comp = (unsigned char *)malloc(samplen[i])) == NULL)
                {
                    for (j = 0; j < i; j++)
                        if (samplen[j] > 0)
                            free(sampptr[j]);
                    fclose(fichier);
                    return(-2); // pas assez de mmoire
                }
                fread(&taille_sample_decomp, 2, 1, fichier);
                if (taille_sample_decomp != 0)
                {
                    if ((sampptr[i] = (unsigned char *)malloc(taille_sample_decomp)) == NULL)
                    {
                        for (j = 0; j < i; j++)
                            if (samplen[j] > 0)
                                free(sampptr[j]);
                        fclose(fichier);
                        return(-2); // pas assez de mmoire
                    }
                    if (fread(sample_comp, samplen[i], 1, fichier) != 1)
                    {
                        for (j = 0; j < i; j++)
                            if (samplen[j] > 0)
                                free(sampptr[j]);
                        fclose(fichier);
                        return(-5); // pas au format MOD
                    }
                    decompresse_sample(i);
                    free(sample_comp);
                    samplen[i] = taille_sample_decomp;
                }
                else
                    free(sample_comp);
            }
            else
            {
                if ((sampptr[i] = (unsigned char *)malloc(samplen[i])) == NULL)
                {
                    for (j = 0; j < i; j++)
                        if (samplen[j] > 0)
                            free(sampptr[j]);
                    fclose(fichier);
                    return(-2); // pas assez de mmoire
                }
                if (fread(sampptr[i], samplen[i], 1, fichier) != 1)
                {
                    for (j = 0; j < i; j++)
                        if (samplen[j] > 0)
                            free(sampptr[j]);
                    fclose(fichier);
                    return(-5); // pas au format MOD
                }
            }
        }

    // patterns:
    if ( (patterns = (unsigned char *)malloc(size_all_pat)) == NULL)
    {
        for (i = 0; i < 31; i++)
            if (samplen[i] > 0)
                free(sampptr[i]);
        fclose(fichier);
        return(-2); // pas assez de memoire
    }
    fread(&taille_pat_comp, 2, 1, fichier);
    if ( (pattern_comp = (unsigned char *)malloc(taille_pat_comp)) == NULL)
    {
        free(patterns);
        for (i = 0; i < 31; i++)
            if (samplen[i] > 0)
                free(sampptr[i]);
        fclose(fichier);
        return(-2); // pas assez de memoire
    }
    if (fread(pattern_comp, taille_pat_comp, 1, fichier) != 1)
    {
        free(patterns);
        free(pattern_comp);
        for (i = 0; i < 31; i++)
            if (samplen[i] > 0)
                free(sampptr[i]);
        fclose(fichier);
        return(-4); // impossible de lire les patterns
    }
    decompresse_patterns();
    free(pattern_comp);

    fclose(fichier);
    return(0);
}

void freemodule()
{
    unsigned char   i;

    free(patterns);
    for (i = 0; i < 64/*31*/; i++)
        if (samplen[i] > 0)
        {
            free(sampptr[i]);
            samplen[i] = 0;
        }
}

int loadsample(unsigned char *nom_fichier_sample, int no_sample, long pos_fin)
{
    FILE    *fichier;

    fichier = fopen(nom_fichier_sample, "rb");
    if (fichier == NULL)
        return -1;
    if (pos_fin != 0)
        fseek(fichier, -pos_fin, SEEK_END);
    fread(&samplen[no_sample], sizeof(unsigned short), 1, fichier);
    fread(&samprep[no_sample], sizeof(unsigned short), 1, fichier);
    fread(&sampreplen[no_sample], sizeof(unsigned short), 1, fichier);
    fread(&sampvol[no_sample], sizeof(unsigned short), 1, fichier);
    sampptr[no_sample] = (unsigned char *)malloc(samplen[no_sample]);
    fread(sampptr[no_sample], samplen[no_sample], 1, fichier);
    fclose(fichier);
    return 0;
}

// ==========================================================================

#ifdef MSDOS
unsigned char read_mixer(unsigned char reg)
{
    outportb(port_sb+4,reg);
    return inportb(port_sb+5);
}
#endif

#ifdef MSDOS
void write_mixer(unsigned char reg, unsigned char val)
{
    outportb(port_sb+4, reg);
    outportb(port_sb+5, val);
}
#endif

int getvolume()
{
    #ifdef MSDOS
        return read_mixer(48) >> 3;
    #else
        int     vol;

        if (sb16_mixer)
        {
            ioctl(mixer, SOUND_MIXER_READ_VOLUME, &vol);
            return (vol & 0xFF);
        }
        else
            return 0;   // pas de mixer trouve a l'initialisation de la SB16
    #endif
}

void setvolume(int vol)
{
    #ifdef MSDOS
        write_mixer(48, (vol << 3));
        write_mixer(49, (vol << 3));
    #else
        if (sb16_mixer)
        {
            vol = (vol << 8)+vol;
            ioctl(mixer, SOUND_MIXER_WRITE_VOLUME, &vol);
        }
    #endif
}
