/* ============================================================================

            MOD_Ados.S: partie assembleur de HMP pour Dos

            (c) 19/02/1999 by FlashCode (Sebastien Helleu)

 ==============================================================================

   ==== This file is part of Hell Module Player (HMP).
   ====
   ==== HMP is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== HMP is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with HMP; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/02/19

2001/09/06: FlashCode:
    - ajout de la licence
*/

/* Variables globales */

.comm   _port_sb,2
.comm   _irq_sb,2
.comm   _doublebuffer,4
.comm   _dmaflag,2
.comm   _dmabuffer,4
.comm   _numtracks,1
.comm   _row,1
.comm   _breakrow,1
.comm   _bpm,1
.comm   _tempo,1
.comm   _tempowait,1
.comm   _tracks,8*34
.comm   _orderpos,1
.comm   _orderlen,1
.comm   _note,4
.comm   _bpmsamples,4
.comm   _buflen,4
.comm   _bufptr,4
.comm   _bufrep,4
.comm   _pitchtable,857*2
.comm   _sampptr,64*4
.comm   _samplen,64*4
.comm   _samprep,64*4
.comm   _sampreplen,64*4
.comm   _sampvol,64*4
.comm   _patterns,4
.comm   _restart,1
.comm   _order,128
.comm   _voltable,16640
.comm   _mixbuffer,4096
.comm   _size_pattern,2
.comm   _module_fini,1

.comm   _g_select,2

/* pour la sauvegarde des pistes 
/*.comm   ofs_pos_sample,4,4 */
/*.comm   buffer_pistes,8000,1 */

.data

.globl sintable
    .align 1
sintable:
    .byte   0
    .byte   25
    .byte   50
    .byte   74
    .byte   98
    .byte   120
    .byte   142
    .byte   162
    .byte   180
    .byte   197
    .byte   212
    .byte   225
    .byte   236
    .byte   244
    .byte   250
    .byte   254
    .byte   255
    .byte   254
    .byte   250
    .byte   244
    .byte   236
    .byte   225
    .byte   212
    .byte   197
    .byte   180
    .byte   162
    .byte   142
    .byte   120
    .byte   98
    .byte   74
    .byte   50
    .byte   25

.globl periodtable
    .align 2
periodtable:
    .word   856
    .word   808
    .word   762
    .word   720
    .word   678
    .word   640
    .word   604
    .word   570
    .word   538
    .word   508
    .word   480
    .word   453
    .word   428
    .word   404
    .word   381
    .word   360
    .word   339
    .word   320
    .word   302
    .word   285
    .word   269
    .word   254
    .word   240
    .word   226
    .word   214
    .word   202
    .word   190
    .word   180
    .word   170
    .word   160
    .word   151
    .word   143
    .word   135
    .word   127
    .word   120
    .word   113

.globl _mixspeed
    .align 2
_mixspeed:
    .word   22000

.text

/* ============================================================================
 BeatTrack:  Process the next beat in one track.
  In:
   EDI = track info address
============================================================================ */

.globl _beattrack

    .align 1
    _beattrack:
        movw 18(%edi),%dx
        test %dx,%dx
        je .none
        cmp $0x00,%dh
        je .arpeggio
        cmp $0x01,%dh
        je .portup
        cmp $0x02,%dh
        je .portdown
        cmp $0x03,%dh
        je .toneport
        cmp $0x04,%dh
        je .vibrato
        cmp $0x05,%dh
        je .portslide
        cmp $0x06,%dh
        je .vibslide
        cmp $0x0a,%dh
        je .volslide
    .none:
        ret
    .arpeggio:
        movw 32(%edi),%bx
        andl $0x0ffff,%ebx
        movw 26(%edi,%ebx),%ax
        movw %ax,16(%edi)
        addw $2,%bx
        cmpw $6,%bx
        jb .setarpindex
        xorw %bx,%bx
    .setarpindex:
        movw %bx,32(%edi)
        ret
    .portup:
        xorb %dh,%dh
        movw 14(%edi),%bx
        subw %dx,%bx
        cmpw $113,%bx
        jge .notsmall
        movw $113,%bx
    .notsmall:
        movw %bx,14(%edi)
        addw %bx,%bx
        andl $0x0ffff,%ebx
        movw _pitchtable(%ebx),%ax
        movw %ax,16(%edi)
        ret

    .portdown:
        xorb %dh,%dh
        movw 14(%edi),%bx
        addw %dx,%bx
        cmpw $856,%bx
        jle .notbig
        movw $856,%bx
    .notbig:
        movw %bx,14(%edi)
        addw %bx,%bx
        andl $0x0ffff,%ebx
        movw _pitchtable(%ebx),%ax
        movw %ax,16(%edi)
        ret
    .toneport:
        xorb %dh,%dh
        movw 20(%edi),%ax
        movw 14(%edi),%bx
        cmpw %ax,%bx
        je .noport
        jg .porttoup
    .porttodown:
        addw %dx,%bx
        cmpw %ax,%bx
        jle .setport
    .fixport:
        movw %ax,%bx
        jmp .setport
    .porttoup:
        subw %dx,%bx
        cmpw %ax,%bx
        jl .fixport
    .setport:
        mov %bx,14(%edi)
        addw %bx,%bx
        andl $0x0ffff,%ebx
        movw _pitchtable(%ebx),%ax
        movw %ax,16(%edi)
    .noport:
        ret
    .vibrato:
        movb %dl,%dh
        andb $0x0f,%dl
        shrb $4,%dh
        shlb $2,%dh
        addb %dh,23(%edi)
        movb 23(%edi),%dh
        movb %dh,%bl
        shrb $2,%bl
        andw $0x1f,%bx
        andl $0x0ffff,%ebx
        movb sintable(%ebx),%al
        mulb %dl
        rolw $1,%ax
        xchg %al,%ah
        andb $1,%ah
        test %dh,%dh
        jns .vibup
        negw %ax
    .vibup:
        addw 14(%edi),%ax
        movw %ax,%bx
        cmpw $113,%bx
        jge .nolovib
        movw $113,%bx
    .nolovib:
        cmpw $856,%bx
        jle .nohivib
        movw $856,%bx
    .nohivib:
        addw %bx,%bx
        andl $0x0ffff,%ebx
        movw _pitchtable(%ebx),%ax
        movw %ax,16(%edi)
        ret
    .portslide:
        call .volslide
        movb 22(%edi),%dl
        jmp .toneport
    .vibslide:
        call .volslide
        movb 24(%edi),%dl
        jmp .vibrato
    .volslide:
        movb %dl,%dh
        andb $0x0f,%dl
        shrb $4,%dh
        movb 12(%edi),%al
        subb %dl,%al
        jge .nolovol
        xorb %al,%al
    .nolovol:
        addb %dh,%al
        cmpb $64,%al
        jbe .nohivol
        movb $64,%al
    .nohivol:
        mov %al,12(%edi)
        ret

/* ============================================================================
 GetTrack:   Get the next Note from a pattern.
  In:
   EDI = track info address
   ESI = pattern note address
 Out:
   ESI = the next pattern note address
============================================================================ */

.globl _gettrack

    .align 1
    _gettrack:

        movw 0(%esi),%ax
        addl $2,%esi

        xchg %al,%ah
        movb %ah,%bl
        andb $0x0f,%ah
        movw %ax,%cx

        movw 0(%esi),%ax
        addl $2,%esi

        xchg %al,%ah
        movb %ah,%bh
        andb $0x0f,%ah
        movw %ax,%dx
        movw %dx,18(%edi)
        andb $0x0f0,%bl
        shrb $4,%bh
        orb %bh,%bl
        je .setperiod
    .setsample:
        xorb %bh,%bh
        decw %bx
        addw %bx,%bx
        andl $0x0ffff,%ebx
        movw _sampvol(%ebx),%ax
        movb %al,12(%edi)
        shlw $1,%bx

        movl _sampptr(%ebx),%eax
        movl %eax,0(%edi)

        shrw $1,%bx
        movw _samplen(%ebx),%ax
        movw %ax,6(%edi)
        movw _samprep(%ebx),%ax
        movw %ax,8(%edi)
        movw _sampreplen(%ebx),%ax
        movw %ax,10(%edi)

    .setperiod:
        test %cx,%cx
        je .seteffect

        movw %cx,20(%edi)
        cmpb $3,%dh
        je .seteffect

        movw %cx,14(%edi)
        movw %cx,%bx
        addw %bx,%bx
        andl $0x0ffff,%ebx
        movw _pitchtable(%ebx),%ax
        movw %ax,16(%edi)
        movw $0,4(%edi)

    .seteffect:
        test %dx,%dx
        je .initnone
        cmpb $0x00,%dh
        je .initarpeggio
        cmpb $0x03,%dh
        je .inittoneport
        cmpb $0x04,%dh
        je .initvibrato
        cmpb $0x09,%dh
        je .sampleofs
        cmpb $0x0b,%dh
        je .posjump
        cmpb $0x0c,%dh
        je .setvolume
        cmpb $0x0d,%dh
        je .break
        cmpb $0x0f,%dh
        je .setspeed
    .initnone:
        ret

    .inittoneport:
        test %dl,%dl
        jne .setportparm
        movb 22(%edi),%dl
    .setportparm:
        movb %dl,22(%edi)
        movw %dx,18(%edi)
        ret

    .initvibrato:
        movb 24(%edi),%al
        movb %al,%ah
        andb $0x0f,%al
        andb $0x0f0,%ah
        test $0x0f,%dl
        jne .okdepth
        orb %al,%dl
    .okdepth:
        test $0x0f0,%dl
        jne .okrate
        or %ah,%dl
    .okrate:
        movb %dl,24(%edi)
        movw %dx,18(%edi)
        test %cx,%cx
        je .okpos
        movb $0,23(%edi)
    .okpos:
        ret

    .sampleofs:
        test %dl,%dl
        jne .setsampleofs
        movb 25(%edi),%dl
    .setsampleofs:
        movb %dl,25(%edi)
        movb %dl,%dh
        xorb %dl,%dl
        movw %dx,4(%edi)
        ret

    .posjump:
        movb %dl,_orderpos
        movb $64,_row
        ret

    .setvolume:
        cmpb $64,%dl
        jbe .okvol
        movb $64,%dl
    .okvol:
        movb %dl,12(%edi)
        ret

    .break:
        movb %dl,%dh
        andb $0x0f,%dl
        shrb $4,%dh
        addb %dh,%dh
        addb %dh,%dl
        shlb $2,%dh
        addb %dh,%dl
        movb %dl,_breakrow
        movb $64,_row
        ret

    .setspeed:
        test %dl,%dl
        je .skip
        cmpb $31,%dl
        ja .setbpm
    .settempo:
        movb %dl,_tempo
        movb %dl,_tempowait
        ret
    .setbpm:
        movb %dl,_bpm
        movb $103,%al
        mulb %dl
        movb %ah,%bl
        xorb %bh,%bh
        movw _mixspeed,%ax
        xorw %dx,%dx
        divw %bx
        andl $0x0ffff,%eax
        movl %eax,_bpmsamples
    .skip:
        ret

    .initarpeggio:
        movb %dl,%dh
        andb $0x0f,%dl
        shrb $4,%dh
        movw $36,%cx
        xorl %ebx,%ebx
        movw 14(%edi),%ax
    .scanperiod:
        cmpw periodtable(%ebx),%ax
        jae .setarp
        addw $2,%bx
        loop .scanperiod
    .setarp:
        addw %dx,%dx
        addb %bl,%dh
        addb %bl,%dl
        movw periodtable(%ebx),%bx
        addw %bx,%bx
        movw _pitchtable(%ebx),%ax
        movw %ax,26(%edi)
        movb %dh,%bl
        xorb %bh,%bh
        movw periodtable(%ebx),%bx
        addw %bx,%bx
        movw _pitchtable(%ebx),%ax
        movw %ax,28(%edi)
        movb %dl,%bl
        xorb %bh,%bh
        movw periodtable(%ebx),%bx
        addw %bx,%bx
        movw _pitchtable(%ebx),%ax
        movw %ax,30(%edi)
        movw $0,32(%edi)
        ret

/* ============================================================================
 UpdateTracks:  Main code to process the next tick to be played.
============================================================================ */

.globl _updatetracks

    .align 1
    _updatetracks:

        decb _tempowait
        je .gettracks

    .beattracks:
        movl $_tracks,%edi
        call _beattrack
        movl $_tracks+34,%edi
        call _beattrack
        movl $_tracks+34*2,%edi
        call _beattrack
        movl $_tracks+34*3,%edi
        call _beattrack
        cmpb $4,_numtracks
        je .noupdate
        movl $_tracks+34*4,%edi
        call _beattrack
        movl $_tracks+34*5,%edi
        call _beattrack
        cmpb $6,_numtracks
        je .noupdate
        movl $_tracks+34*6,%edi
        call _beattrack
        movl $_tracks+34*7,%edi
        call _beattrack
        ret

    .gettracks:
        movb _tempo,%al
        movb %al,_tempowait

        movl _note,%esi
        cmpb $64,_row
        jb .nopattwrap

        movl _patterns,%esi
        movb _orderpos,%bl
        cmpb _orderlen,%bl
        jb .noorderwrap

        cmpb $1,_music_stop_at_end
        jne .restartmodule
        movl $_mixbuffer,%edi
        movl $4096,%ecx
        movb $0x80,%al
        rep
        stosb
        movb $1,_module_fini
        jmp .noupdate

    .restartmodule:
        movb _restart,%bl
        movb %bl,_orderpos
        cmpb _orderlen,%bl
        jae .noupdate
    .noorderwrap:
        xorb %bh,%bh
        andl $0x0ffff,%ebx
        movb _order(%ebx),%bl
        movw _size_pattern,%ax
        mulw %bx
        andl $0x0ffff,%eax
        addl %eax,%esi
        movb _breakrow,%bl
        movb %bl,_row
        xorb %bh,%bh
        movb %bh,_breakrow
        shlw $4,%bx
        andl $0x0ffff,%ebx
        addl %ebx,%esi
        movl %esi,_note
        incb _orderpos
    .nopattwrap:
        incb _row

        cld

        movl $_tracks,%edi
        call _gettrack
        movl $_tracks+34,%edi
        call _gettrack
        movl $_tracks+34*2,%edi
        call _gettrack
        movl $_tracks+34*3,%edi
        call _gettrack
        cmpb $4,_numtracks
        je .aftergettrack
        movl $_tracks+34*4,%edi
        call _gettrack
        movl $_tracks+34*5,%edi
        call _gettrack
        cmpb $6,_numtracks
        je .aftergettrack
        movl $_tracks+34*6,%edi
        call _gettrack
        movl $_tracks+34*7,%edi
        call _gettrack

    .aftergettrack:
        movl %esi,_note
    .noupdate:
        ret

/* ============================================================================
 MixTrack:  Mixes one track into a CLEAN buffer.
  In:
   ESI = track info address
   EDI = buffer address
   ECX = buffer size
============================================================================ */

.globl _mixtrack

    .align 1
    _mixtrack:

        cmpw $2,10(%esi)
        ja .mixlooped

    .mixnonlooped:
        movl 0(%esi),%edx
        movw 4(%esi),%bx
        andl $0x0ffff,%ebx
        movw 6(%esi),%bp
        andl $0x0ffff,%ebp
        push %edx
        push %esi
        addl %edx,%ebx

        addl %edx,%ebp
        movw 16(%esi),%dx
        andl $0x0ffff,%edx
        movb 12(%esi),%al
        movb 13(%esi),%ah
        movl %ebx,%esi
        movb %al,%bh
        movb %dl,%al
        movb %dh,%dl
        xorb %dh,%dh
        andl $0x0ffff,%ebx
    .nlmixsamp:
        cmpl %ebp,%esi
        jae .nlmixbye
        movb 0(%esi),%bl
        movb _voltable(%ebx),%bl
        push %es
        #ifdef MSDOS
        movw _g_select, %es
        #endif
        addb %bl,%es:(%edi)
        pop %es
        incl %edi
        addb %al,%ah
        adcl %edx,%esi
        loop .nlmixsamp
    .nlmixbye:
        movl %esi,%ebx
        popl %esi
        popl %edx
        subl %edx,%ebx
        movw %bx,4(%esi)
        movb %ah,13(%esi)
        ret

.mixlooped:
        movl 0(%esi),%edx
        movw 4(%esi),%bx
        andl $0x0ffff,%ebx
        movw 10(%esi),%bp
        andl $0x0ffff,%ebp
        movl %ebp,_bufrep
        addw 8(%esi),%bp
        push %edx
        push %esi
        addl %edx,%ebx
        addl %edx,%ebp
        movw 16(%esi),%dx
        andl $0x0ffff,%edx
        movb 12(%esi),%al
        movb 13(%esi),%ah
        movl %ebx,%esi
        movb %al,%bh
        movb %dl,%al
        movb %dh,%dl
        xorb %dh,%dh
        andl $0x0ffff,%ebx
    .lpmixsamp:
        cmpl %ebp,%esi
        jb .lpmixnow
        subl _bufrep,%esi
    .lpmixnow:
        movb 0(%esi),%bl
        movb _voltable(%ebx),%bl
        push %es
        #ifdef MSDOS
        movw _g_select, %es
        #endif
        addb %bl,%es:(%edi)
        pop %es
        incl %edi
        addb %al,%ah
        adcl %edx,%esi
        loop .lpmixsamp
    .lpmixbye:
        movl %esi,%ebx
        pop %esi
        pop %edx
        subl %edx,%ebx
        movw %bx,4(%esi)
        movb %ah,13(%esi)
        ret

/* ============================================================================
 GetSamples:  Returns the next chunk of samples to be played.
  In:
   EDI = buffer address
   EBX = buffer size
============================================================================ */

.globl _getsamples

    .align 1
    _getsamples:

        pusha
        cld

    .nextchunk:
        cmpl $0,_buflen
        jne .copychunk

        push %ebx
        push %edi

    .mixchunk:
        movl $_mixbuffer,%edi
        movl _bpmsamples,%ecx
        movl %edi,_bufptr
        movl %ecx,_buflen

        push %es
        #ifdef MSDOS
        movw _g_select, %es
        #endif
        movb $0x80,%al
        rep
        stosb
        pop %es

        movl $_tracks,%esi
        movl _bufptr,%edi
        movl _buflen,%ecx
        call _mixtrack

        movl $_tracks+34,%esi
        movl _bufptr,%edi
        movl _buflen,%ecx
        call _mixtrack

        movl $_tracks+34*2,%esi
        movl _bufptr,%edi
        movl _buflen,%ecx
        call _mixtrack

        movl $_tracks+34*3,%esi
        movl _bufptr,%edi
        movl _buflen,%ecx
        call _mixtrack

        cmpb $4,_numtracks
        je .aftermixtrack
        movl $_tracks+34*4,%esi
        movl _bufptr,%edi
        movl _buflen,%ecx
        call _mixtrack

        movl $_tracks+34*5,%esi
        movl _bufptr,%edi
        movl _buflen,%ecx
        call _mixtrack

        cmpb $6,_numtracks
        je .aftermixtrack
        movl $_tracks+34*6,%esi
        movl _bufptr,%edi
        movl _buflen,%ecx
        call _mixtrack

        movl $_tracks+34*7,%esi
        movl _bufptr,%edi
        movl _buflen,%ecx
        call _mixtrack

    .aftermixtrack:
        call _updatetracks

        pop %edi
        pop %ebx

    .copychunk:
        movl _buflen,%ecx
        cmpl %ebx,%ecx
        jbe .movechunk
        movl %ebx,%ecx

    .movechunk:
        movl _bufptr,%esi
        addl %ecx,_bufptr
        subl %ecx,_buflen
        subl %ecx,%ebx
        push %es
        #ifdef MSDOS
        movw _g_select, %es
        #endif
        push %ds
        #ifdef MSDOS
        movw _g_select, %ds
        #endif
        rep
        movsb
        pop %ds
        pop %es
        test %ebx,%ebx
        jne .nextchunk

        popa
        ret


/* ============================================================================
 StartPlaying: Initializes the Sound System.
  In:
   Module Information Resources.
============================================================================ */

.globl _startplaying

    .align 1
    _startplaying:

        pusha

    .setmodparms:
        movb $0,_orderpos
        movb $6,_tempo
        movb $6,_tempowait
        movb $125,_bpm
        movb $65,_row
        movb $0,_breakrow
        movw _mixspeed,%ax
        xorw %dx,%dx
        movw $50,%bx
        divw %bx
        andl $0x0ffff,%eax
        movl %eax,_bpmsamples

    .cleartracks:
        movl $_tracks,%edi
        movl $272,%ecx
        xorl %eax,%eax
        cld
        rep
        stosb

        movl %eax,_bufptr
        movl %eax,_buflen

    .makepitch:
        movw $8448,%ax
        movw $428,%bx
        mulw %bx
        divw _mixspeed
        xorb %dh,%dh
        movb %ah,%dl
        movb %al,%ah
        xorb %al,%al
        movl $857,%ecx
        xorw %bx,%bx
        movl $_pitchtable,%edi
    .pitchloop:
        push %ax
        push %dx
        cmpw %bx,%dx
        jae .nodiv
        divw %bx
    .nodiv:
        stosw
        pop %dx
        pop %ax
        incw %bx
        loop .pitchloop

    .makevolume:
        movl $_voltable,%esi
        movl $16640,%ecx
        movl %ecx,%ebx
    .volloop:
        decw %bx
        movb %bl,%al
        imulb %bh
        movb %ah,(%esi,%ebx)
        loop .volloop

        popa
        ret

/* ============================================================================
 SbPoll:  Sound Blaster Polling. (=== DOS ONLY ! ===)
============================================================================ */

.globl _sbpoll

    .align 1
    _sbpoll:

        pusha

    .getdmacount:
        in $0x03,%al
        movb %al,%cl
        in $0x03,%al
        movb %al,%ch

        movw _dmaflag,%ax
        test %ax,%ax
        jne .secondhalf

    .firsthalf:
        cmpw $1024,%cx
        jae .bye
        movl _dmabuffer,%edi
        movl $1024,%ebx
        call _getsamples
        incw _dmaflag
        jmp .bye

    .secondhalf:
        cmpw $1024,%cx
        jb .bye
        movl _dmabuffer,%edi
        movl $1024,%ebx
        addl %ebx,%edi
        call _getsamples
        decw _dmaflag

    .bye:
        popa
        ret
