/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== playfli.c: player de FLI pour FlashTris
   ====

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifndef MSDOS
    #include <unistd.h>
    #include <vga.h>
    #include <vgakeyboard.h>
#endif

#include "playfli.h"
#include "ftris.h"
#include "video.h"
#include "data_exe.h"


void            *buffer_fli;

int             fli_pos_image[32];
int             fli_nb_chunks;


unsigned short  nb_chunks;

/*
 * fli_calcule_pos_images: calcule la position des images dans le buffer FLI
 */

void fli_calcule_pos_images(void *fli)
{
    int     i, j, pos, image;

    pos = 0;
    image = 0;
    for (i = 0; i < 31; i++)
    {
        nb_chunks = (unsigned short)*((unsigned short *)(fli+pos+6));
        pos += 16;
        for (j = 0; j < nb_chunks; j++)
        {
            fli_pos_image[image] = pos;
            image++;
            pos += (int)*((int *)(fli+pos));
        }
    }
    fli_nb_chunks = image;
}

/*
 * load_fli: charge un FLI en memoire
 */

int load_fli(unsigned char *nom_fli)
{
    FILE    *f;
    long    taille;

    #ifdef DATA_EXE
    taille = taille_fichier(nom_fli);
    if ( (f = fopen(argv0, "rb")) == NULL)
        return -1;
    if (fseek(f, -position_fichier(nom_fli), SEEK_END) != 0)
        { fclose(f); return -2; }
    #else
    unsigned char   nom_complet[256];

    sprintf(nom_complet, "%s%s", PATH_GFX, nom_fli);
    if ( (f = fopen(nom_complet, "rb")) == NULL)
        return -1;
    if (fseek(f, 0, SEEK_END) != 0)
        { fclose(f); return -2; }
    taille = ftell(f);
    if (fseek(f, 0, SEEK_SET) != 0)
        { fclose(f); return -2; }
    #endif
    buffer_fli = (void *)ftris_malloc(taille, "animation buffer");
    fread(buffer_fli, 1, taille, f);
    fclose(f);
    fli_calcule_pos_images(buffer_fli);
    return 0;
}


int             i, j, k, l;
unsigned short  nb_diff, curx, cury, type_chunk, size_chunk, nb_change, count;
unsigned char   nb_packets, skipcount, octet;
int             buf_fli_ptr, futur_fli_ptr;
unsigned short  ecran_ptr;

/*
 * play_fli: joue le FLI en mode 320x200x256
 */

void play_fli(void *fli)
{
    buf_fli_ptr = 0;
    for (i = 0; i < fli_nb_chunks; i++)
    {
        /*nb_chunks = (unsigned short)*((unsigned short *)(fli+buf_fli_ptr+6));
        buf_fli_ptr += 16;
        for (j = 0; j < nb_chunks; j++)*/
        {
            buf_fli_ptr = fli_pos_image[i];
            size_chunk = (int)*((int *)(fli+buf_fli_ptr));
            type_chunk = (unsigned short)*((unsigned short *)(fli+buf_fli_ptr+4));
            futur_fli_ptr = buf_fli_ptr+size_chunk;
            buf_fli_ptr += 6;
            waitretrace();
            waitretrace();
            switch (type_chunk)
            {
                case FLI_COPY:
                    copy_buf2s((unsigned char *)(fli+buf_fli_ptr), 0, 0, 64000);
                    buf_fli_ptr = futur_fli_ptr;
                    break;
                case FLI_BLACK:
                    clear_screen();
                    buf_fli_ptr = futur_fli_ptr;
                    break;
                case FLI_COLOR:
                    nb_packets = (unsigned char)*((unsigned char *)(fli+buf_fli_ptr));
                    buf_fli_ptr += 2;
                    for (k = 0; k < nb_packets; k++)
                    {
                        skipcount = (unsigned char)*((unsigned char *)(fli+buf_fli_ptr));
                        nb_change = (unsigned char)*((unsigned char *)(fli+buf_fli_ptr+1));
                        buf_fli_ptr += 2;
                        if (nb_change == 0)
                            nb_change = 256;
                        memcpy(&palette[skipcount*3], fli+buf_fli_ptr, nb_change*3);
                        buf_fli_ptr += nb_change*3;
                    }
                    setpal(palette);
                    /*for (k = 0; k < 256; k++)
                        setcoul(k, palette[k*3], palette[k*3+1], palette[k*3+2]);*/
                    buf_fli_ptr = futur_fli_ptr;
                    break;
                case FLI_LC:
                    cury = (unsigned short)*((unsigned short *)(fli+buf_fli_ptr));
                    nb_diff = (unsigned short)*((unsigned short *)(fli+buf_fli_ptr+2));
                    buf_fli_ptr += 4;
                    for (k = 0; k < nb_diff; k++)
                    {
                        curx = 0;
                        nb_packets = (unsigned char)*((unsigned char *)(fli+buf_fli_ptr));
                        buf_fli_ptr++;
                        for (l = 0; l < nb_packets; l++)
                        {
                            skipcount = (unsigned char)*((unsigned char *)(fli+buf_fli_ptr));
                            buf_fli_ptr++;
                            curx += skipcount;
                            count = (unsigned char)*((unsigned char *)(fli+buf_fli_ptr));
                            buf_fli_ptr++;
                            if (count < 128)
                            {
                                /*memcpy(&adr_ecran[cury*320+curx], fli+buf_fli_ptr, count);*/
                                copy_buf2s((unsigned char *)(fli+buf_fli_ptr), curx, cury, count);
                                buf_fli_ptr += count;
                                curx += count;
                            }
                            else
                            {
                                count = 256-count;
                                octet = (unsigned char)*((unsigned char *)(fli+buf_fli_ptr));
                                buf_fli_ptr++;
                                /*memset(&adr_ecran[cury*320+curx], octet, count);*/
                                ligne_horiz(ECRAN_REEL, curx, curx+count-1, cury, octet);
                                curx += count;
                            }
                        }
                        cury++;
                    }
                    buf_fli_ptr = futur_fli_ptr;
                    break;
                case FLI_BRUN:
                    ecran_ptr = 0;
                    for (k = 0; k < 200; k++)
                    {
                        nb_packets = (unsigned char)*((unsigned char *)(fli+buf_fli_ptr));
                        buf_fli_ptr++;
                        for (l = 0; l < nb_packets; l++)
                        {
                            count = (unsigned char)*((unsigned char *)(fli+buf_fli_ptr));
                            buf_fli_ptr++;
                            if (count < 128)
                            {
                                octet = (unsigned char)*((unsigned char *)(fli+buf_fli_ptr));
                                buf_fli_ptr++;
                                /*memset(&adr_ecran[ecran_ptr], octet, count);*/
                                ligne_horiz(ECRAN_REEL, ecran_ptr%320, ecran_ptr%320+count-1, ecran_ptr/320, octet);
                                ecran_ptr += count;
                            }
                            else
                            {
                                count = 256-count;
                                /*memcpy(&adr_ecran[ecran_ptr], fli+buf_fli_ptr, count);*/
                                copy_buf2s((unsigned char *)(fli+buf_fli_ptr), ecran_ptr%320, ecran_ptr/320, count);
                                ecran_ptr += count;
                                buf_fli_ptr += count;
                            }
                        }
                    }
                    buf_fli_ptr = futur_fli_ptr;
                    break;
            }
        }
    }
}
